
/*
 * @(#)AbstractSessionProxy.java	1.1 97/05/15
 *
 * Copyright (c) 1993-1997 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You shall
 * not disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */

package SharedData;

import SharedData.primitive.SharedByteArrayObserver;

/**
 * Shared Data abstract client-side Session proxy interface.
 *
 * @version     0.94 7 April 1997
 * @author      Rich Burridge
 */

public interface
AbstractSessionProxy extends AbstractSharedDataProxy {

    void
    joinSession(Client client, boolean authenticate)
                                         throws SharedDataException;

    Channel
    joinChannel(Session session, String channelName, Client client,
                int mode, boolean authenticate) throws SharedDataException;

    Token
    joinToken(Session session, String tokenName, Client client)
                                           throws SharedDataException;

    void
    attachSessionManager(SessionManager sessionManager,
                         Session session) throws SharedDataException;

    String[]
    listByteArrayNames() throws SharedDataException;

    String[]
    listChannelNames() throws SharedDataException;

    String[]
    listTokenNames() throws SharedDataException;

    String
    createChannel(String channelName, ChannelManager channelManager,
                  boolean reliable) throws SharedDataException;

    String
    createToken(String tokenName, TokenManager tokenManager)
                                                throws SharedDataException;

    void
    addByteArrayObserver(String byteArrayName,
                SharedByteArrayObserver observer) throws SharedDataException;

    void
    deleteByteArrayObserver(String byteArrayName,
                SharedByteArrayObserver observer) throws SharedDataException;

    void
    createByteArray(Client client, SharedByteArrayObserver observer,
                    String byteArrayName, byte[] value,
                    int length) throws SharedDataException;

    void
    destroyByteArray(Client client, 
		     String byteArrayName) throws SharedDataException;

    void
    updateByteArray(Client client, String byteArrayName,
                    byte[] value, int length) throws SharedDataException;
}
