
/*
 * @(#)AbstractSharedDataProxy.java	1.1 97/05/15
 *
 * Copyright (c) 1993-1997 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You shall
 * not disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */

package SharedData;

/**
 * Shared Data client-side abstract proxy parent class.
 *
 * @version     0.89 29 January 1997
 * @author      Rich Burridge
 */

public interface
AbstractSharedDataProxy {

    void
    initProxy(String name, Session session, Object object);

    Object
    getProxy();

    void
    addObserver(SharedDataObserver observer, String observerType)
                                        throws SharedDataException;

    void
    deleteObserver(SharedDataObserver observer, String observerType)
                                        throws SharedDataException;

    void
    expel(Client[] clients, String objectType) throws SharedDataException;

    void 
    invite(Client[] clients, String objectType) throws SharedDataException;

    void
    leave(Client client, String objectType) throws SharedDataException;

    String[]
    listClientNames(String objectType) throws SharedDataException;
}
