
/*
 * @(#)ChannelConsumer.java	1.2 97/05/28
 *
 * Copyright (c) 1993-1997 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You shall
 * not disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */

package SharedData;

/**
 * Shared Data Channel Consumer interface.
 *
 * @version     0.96 21 May 1997
 * @author      Rich Burridge
 */

public interface
ChannelConsumer {

/**
 * <A NAME="SD_DATARECEIVED"></A>
 * <EM>dataReceived</EM> is called when data is received for this client on
 * the given channel. This interface is used for normal data and for
 * uniformly sequenced data.
 *
 * The data object received is to a copy of the client data which this
 * consumer can do with as they require.
 *   
 * <EM>IMPORTANT NOTE:</EM>
 * This method can potentially be called multiple times concurrently. To
 * protect again this, classes which implement the ChannelConsumer interface
 * should make sure they use the <EM>synchronized</EM> keyword. Ie:
 *
 * <PRE>
 *     public synchronized void
 *     dataReceived(Data data);
 * </PRE>
 *
 * @param <EM>data</EM> the data which can be of unlimited size.
 */
 
 
    public void
    dataReceived(Data data);
}
