
/*
 * @(#)ChannelEvent.java	1.1 97/05/15
 *
 * Copyright (c) 1993-1997 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You shall
 * not disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */

package SharedData;

/**
 * Shared Data Channel Event class.
 *
 * @version     0.83 9 October 1996
 * @author      Rich Burridge
 */

public class
ChannelEvent extends SharedDataEvent {

    /** The channel this event occured on. */
    protected Channel channel;

/**
 * <A NAME="SD_CHANNELEVENT"></A>
 * <EM>ChannelEvent</EM> the constructor for the ChannelEvent class.
 * A new channel event is generated for a client action for a specific channel.
 *
 * @param <EM>session</EM> the session this channel belongs to.
 * @param <EM>clientName</EM> the name of the client.
 * @param <EM>channel</EM> the channel.
 * @param <EM>type</EM> the type of event.
 */

    public 
    ChannelEvent(Session session, String clientName,
                 Channel channel, int type) {
        if (ChannelEvent_Debug) {
            System.out.println("ChannelEvent: constructor " +
                               " session name: " + session.getName() +
                               " client name: "  + clientName +
                               " channel name: " + channel.getName() +
                               " type: "         + type);
        }

        this.session    = session;
        this.clientName = clientName;
        this.channel    = channel;
        this.type       = type;
    }


/**
 * <A NAME="SD_GETCHANNEL"></A>
 * <EM>getChannel</EM> get the name of the channel for this event.
 *
 * @return the name of the channel for this event.
 */
 
    public Channel
    getChannel() {
        if (ChannelEvent_Debug) {
            System.out.println("ChannelEvent: getChannel: " + channel);
        }
        return(channel);
    }
}
