
/*
 * @(#)SessionEvent.java	1.1 97/05/15
 *
 * Copyright (c) 1993-1997 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You shall
 * not disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */

package SharedData;

/**
 * Shared Data SessionEvent class.
 *
 * @version     0.83 9 October 1996
 * @author      Rich Burridge
 */

public class
SessionEvent extends SharedDataEvent {

/**
 * <A NAME="SD_SESSIONEVENT"></A>
 * <EM>SessionEvent</EM> the constructor for the SessionEvent class.
 * A new session event is generated for a client action within the given
 * session.
 *
 * @param <EM>session</EM> the session in question.
 * @param <EM>clientName</EM> the name of the client. 
 * @param <EM>type</EM> the type of event.
 */

    public
    SessionEvent(Session session, String clientName, int type) {
        if (SessionEvent_Debug) {
            System.out.println("SessionEvent: constructor " +
                               " session name: " + session.getName() +
                               " client name: "  + clientName +
                               " type: "         + type);
        }

        this.session    = session;
        this.clientName = clientName;
        this.type       = type;
    }
}
