
/*
 * @(#)ClientProxy.java	1.1 97/05/15
 *
 * Copyright (c) 1993-1997 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You shall
 * not disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */

package SharedData.socket;

import SharedData.*;

/**
 * Shared Data Client client-side proxy class.
 *
 * @version     0.90 11 February 1997
 * @author      Rich Burridge
 */

class
ClientProxy extends SharedDataProxy {

    /** The name of this client client. */
    protected String name = null;

    /** The client-side client associated with this client client. */
    protected Client client;

    /** Proxy thread for this client. */
    ClientProxyThread proxyThread;


/**
 * <A NAME="SD_CLIENTPROXY"></A>
 * <EM>ClientProxy</EM>
 *
 * @param <EM>client</EM>
 * @param <EM>name</EM>
 * The socket client proxy name cannot include '\u0001' or newline characters.
 * @param <EM>host</EM>
 * @param <EM>port</EM>
 */

    public
    ClientProxy(Client client, String name, String host, int port) {
        Thread thread;

        if (ClientProxy_Debug) {
            System.out.println("ClientProxy: constructor:" +
                               " client: " + client +
                               " name: "   + name +
                               " host: "   + host +
                               " port: "   + port);
        }

        this.client = client;
        this.name   = name;
        proxyThread = new ClientProxyThread(client, host, port);
        System.out.println("New ClientProxyThread started");
        thread      = new Thread(proxyThread);
    
        thread.start();
        System.out.println("This thread started..");
    }

/*  Note that nothing should be sending messages to the client client-side
 *  object, hence no parseServerClientMessage(tok, thread) method declaration.
 */

}
