
/*
 * @(#)ClientProxyMessage.java	1.1 97/05/15
 *
 * Copyright (c) 1993-1997 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You shall
 * not disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */

package SharedData.socket;

import SharedData.*;
import java.util.StringTokenizer;

/**
 * Shared Data client proxy message class.
 *
 * @version     0.83 9 October 1996
 * @author      Rich Burridge
 */

class
ClientProxyMessage extends SharedDataMessage {

    /** The client associated with this client proxy message. */
    private Client client;

    /** Client proxy thread associated with this message. */
    private ClientProxyThread thread;


/**
 * <A NAME="SD_CLIENTPROXYMESSAGE"></A>
 * <EM>ClientProxyMessage</EM>
 *
 * @param <EM>client</EM>
 * @param <EM>thread</EM>
 */

    public
    ClientProxyMessage(Client client, ClientProxyThread thread) {
        if (ClientProxyMessage_Debug) {
            System.out.println("ClientProxyMessage: constructor:" +
                               " client: "  + client +
                               " thread: "  + thread);
        }
 
        this.client = client;
	this.thread = thread;
    }


/**
 * <A NAME="SD_HANDLEMESSAGE"></A>
 * <EM>handleMessage</EM>
 *
 * @param <EM>tok</EM>
 */

    protected void
    handleMessage(StringTokenizer tok) {
        String type = null;

	if (ClientProxyMessage_Debug) {
            System.out.println("ClientProxyMessage: handleMessage:" +
                               " tok: " + tok);
        }

	type = tok.nextToken();
        System.out.println("ClientProxyMessage: handleMessage:" +
                           " unknown type: " + type);
    }
}
