
/*
 * @(#)ClientProxyThread.java	1.1 97/05/15
 *
 * Copyright (c) 1993-1997 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You shall
 * not disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */

package SharedData.socket;

import SharedData.*;
import java.util.StringTokenizer; 

/**
 * Shared Data Client proxy thread class.
 *
 * @version     0.89 27 January 1997
 * @author      Rich Burridge
 */

class
ClientProxyThread extends TCPSocketThread {

    /** The Client-side client associated with this thread. */
    private Client client;


/**
 * <A NAME="SD_CLIENTPROXYTHREAD"></A>
 * <EM>ClientProxyThread</EM>
 *
 * @param <EM>client</EM>
 * @param <EM>host</EM>
 * @param <EM>port</EM>
 */

    public
    ClientProxyThread(Client client, String host, int port) {
        super(host, port);

        if (ClientProxyThread_Debug) {
            System.out.println("ClientProxyThread: constructor:" +
                               " host: "   + host +
                               " port: "   + port +
                               " client: " + client);
        }

        this.client = client;
    }


/**
 * <A NAME="SD_HANDLEMESSAGE"></A>
 * <EM>handleMessage</EM>
 *
 * @param <EM>message</EM>
 */

    protected void
    handleMessage(String message) {
        StringTokenizer tok = new StringTokenizer(message, T_Sep, false);

        if (ClientProxyThread_Debug) {
            System.out.println("ClientProxyThread: handleMessage:" +
                               " message: " + message);
        }
 
        if (validMessageHeader(tok) != null) {
            ClientProxyMessage cpm = new ClientProxyMessage(client, this);

            cpm.handleMessage(tok);
        }
    }
}
