
/*
 * @(#)ClientServer.java	1.1 97/05/15
 *
 * Copyright (c) 1993-1997 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You shall
 * not disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */

package SharedData.socket;

import SharedData.*;
import java.util.StringTokenizer;

/**
 * Shared Data Client Server-side class.
 *
 * @version     0.90 11 February 1997
 * @author      Rich Burridge
 */

class
ClientServer extends SharedDataServer {

    /** The name of this session server. */
    protected String name = null;

    /** The server-side client associated with this client server. */
    protected Client client;

    /** Server socket instance for this client. */
    SocketServer socketServer;


/**
 * <A NAME="SD_CLIENTSERVER"></A>
 * <EM>ClientServer</EM>
 *
 * @param <EM>client</EM>
 * @param <EM>name</EM>
 * The socket client server name cannot include '\u0001' or newline characters.
 * @param <EM>port</EM>
 */

    public
    ClientServer(Client client, String name, int port) {
        Thread thread = null;

        if (ClientServer_Debug) {
            System.out.println("ClientServer: constructor:" +
                               " client: " + client +
                               " name: "   + name +
                               " port: "   + port);
        }

        this.client  = client;
        this.name    = name;
        socketServer = new TCPSocketServer(port, client);
        thread       = new Thread(socketServer);
        thread.start();
    }


/**
 * <A NAME="SD_PARSEPROXYCLIENTMESSAGE"></A>
 * <EM>parseProxyClientMessage</EM>
 *
 * @param <EM>tok</EM>
 * @param <EM>thread</EM>
 */

    void
    parseProxyClientMessage(StringTokenizer tok,
                              ClientServerThread thread) {
        String action     = tok.nextToken();
        String objectName = tok.nextToken();

        if (ClientServer_Debug) {
            System.out.println("ClientServer: parseProxyClientMessage:" +
                               " action: "      + action +
                               " object name: " + objectName);
        }

        if (action.equals(T_Invite)) {                      /* INVITE. */
	    ClientMessage cm = new ClientMessage(client, objectName,
                                                 ClientEvent.SESSION_INVITE);
	    Thread clientThread = new Thread(cm);

	    clientThread.start();
        } else {
            System.out.println("ClientServer: parseProxyClientMessage:" +
                               " unexpected action: " + action);
        }
    }
}
