
/*
 * @(#)ClientServerMessage.java	1.1 97/05/15
 *
 * Copyright (c) 1993-1997 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You shall
 * not disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */

package SharedData.socket;

import SharedData.*;
import java.util.StringTokenizer;

/**
 * Shared Data client server message class.
 *
 * @version     0.94 7 April 1997
 * @author      Rich Burridge
 */

class
ClientServerMessage extends SharedDataMessage {

    /** The client associated with this client server message. */
    private Client client;

    /** Client server thread associated with this message. */
    private ClientServerThread thread;


/**
 * <A NAME="SD_CLIENTSERVERMESSAGE"></A>
 * <EM>ClientServerMessage</EM>
 *
 * @param <EM>client</EM>
 * @param <EM>thread</EM>
 */

    public
    ClientServerMessage(Client client, ClientServerThread thread) {
        if (ClientServerMessage_Debug) {
            System.out.println("ClientServerMessage: constructor:" +
                               " client: " + client +
                               " thread: " + thread);
        }
 
        this.client = client;
	this.thread = thread;
    }


/**
 * <A NAME="SD_HANDLEMESSAGE"></A>
 * <EM>handleMessage</EM>
 *
 * @param <EM>tok</EM>
 */

    protected void
    handleMessage(StringTokenizer tok) {
        int    id   = Integer.parseInt(tok.nextToken());
        String type = tok.nextToken();

	if (ClientServerMessage_Debug) {
            System.out.println("ClientServerMessage: handleMessage:" +
                               " tok: " + tok);
        }

        if (type.equals(Session.M_Session)) {
            ((socketClient) client).cs.parseProxyClientMessage(tok, thread);
        } else {
            System.out.println("ClientServerMessage: handleMessage:" +
                               " unknown type: " + type);
        }
    }
}
