
/*
 * @(#)ClientServerThread.java	1.1 97/05/15
 *
 * Copyright (c) 1993-1997 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You shall
 * not disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */

package SharedData.socket;

import SharedData.*;
import java.net.Socket;
import java.util.StringTokenizer;

/**
 * Shared Data Client Server Thread class.
 *
 * @version     0.94 7 April 1997
 * @author      Rich Burridge
 */
 
class
ClientServerThread extends TCPSocketThread {
 
    /** The Server-side client associated with this thread. */
    private Client client;


/**
 * <A NAME="SD_CLIENTSERVERTHREAD"></A>
 * <EM>ClientServerThread</EM>
 *
 * @param <EM>socket</EM>
 * @param <EM>client</EM>
 */

    public
    ClientServerThread(Socket socket, Client client) {
        super(socket);

	if (ClientServerThread_Debug) {
            System.out.println("ClientServerThread: constructor:" +
			       " socket: " + socket +
			       " client: " + client);
        }

	this.client = client;
    }    


/**
 * <A NAME="SD_HANDLEMESSAGE"></A>
 * <EM>handleMessage</EM>
 *
 * @param <EM>message</EM>
 */

    protected void
    handleMessage(String message) {
        StringTokenizer tok = new StringTokenizer(message, T_Sep, false);

        if (ClientServerThread_Debug) {
            System.out.println("ClientServerThread: handleMessage:" +
                               " tok: " + tok);
        }
 
        if (validMessageHeader(tok) != null) {
            ClientServerMessage csm = new ClientServerMessage(client, this);
 
            csm.handleMessage(tok);
        }
    }
}
