
/*
 * @(#)SharedByteArrayObserverImpl.java	1.1 97/05/15
 *
 * Copyright (c) 1993-1997 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You shall
 * not disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */

package SharedData.socket;

import SharedData.primitive.SharedByteArrayEvent;
import SharedData.primitive.SharedByteArrayObserver;

/**
 * Shared Byte Array Observer implementation.
 *
 * @version     0.89 28 January 1997
 * @author      Rich Burridge
 */

class
SharedByteArrayObserverImpl extends socketSharedDataObject
			    implements SharedByteArrayObserver {

    /** The name of this shared byte array observer. */
    protected String name;


/**
 * <A NAME="SD_SHAREDBYTEARRAYOBSERVERIMPL"></A>
 * <EM>SharedByteArrayObserverImpl</EM> the constructor for the
 *  SharedByteArrayObserverImpl class.
 *
 * @param <EM>name</EM> the name of the observer being constructed.
 * This name cannot include '\u0001' or newline characters. 
 */

    SharedByteArrayObserverImpl(String name) {
        if (SharedByteArrayObserverImpl_Debug) {
            System.out.println("SharedByteArrayObserverImpl: constructor: " +
			       " name: " + name);
        }

        this.name = name;
    }    


/**
 * <A NAME="SD_GETNAME"></A>
 * <EM>getName</EM> get the name of this observer.
 *
 * @return the name of the observer.
 * The observer name cannot include '\u0001' or newline characters. 
 */

    public String
    getName() {
        if (SharedByteArrayObserverImpl_Debug) {
            System.out.println("SharedByteArrayObserverImpl: getName: " +
			       " name: " + name);
        }
        return(name);
    }


/**
 * <A NAME="SD_VALUECHANGED"></A>
 * <EM>valueChanged</EM> is called when the value of a shared byte array
 * has been changed.
 *
 * @param <EM>event</EM> the shared byte array changed event containing
 * more information on exactly what has changed.
 */

    public void
    valueChanged(SharedByteArrayEvent event) {
        if (SharedByteArrayObserverImpl_Debug) {
            System.out.println("SharedByteArrayObserverImpl: valueChanged:");
        }
    }
}
