
/*
 * @(#)SharedDataObserverImpl.java	1.1 97/05/15
 *
 * Copyright (c) 1993-1997 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You shall
 * not disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */

package SharedData.socket;

/**
 * Shared Data Observer implementation.
 *
 * @version     0.89 28 January 1997
 * @author      Rich Burridge
 */

class
SharedDataObserverImpl extends socketSharedDataObject
		       implements SharedData.SharedDataObserver {

    /** The name of this session observer. */
    protected String name;


/**
 * <A NAME="SD_SHAREDDATAOBSERVERIMPL"></A>
 * <EM>SharedDataObserverImpl</EM> the constructor for the
 *  SharedDataObserverImpl class.
 *
 * @param <EM>name</EM> the name of the observer being constructed.
 * This name cannot include '\u0001' or newline characters. 
 */

    public
    SharedDataObserverImpl(String name) {
        if (SharedDataObserverImpl_Debug) {
            System.out.println("SharedDataObserverImpl: constructor: " + name);
        }

        this.name = name;
    }    


/**
 * <A NAME="SD_GETNAME"></A>
 * <EM>getName</EM> get the name of this observer.
 *
 * @return the name of the observer.
 * The observer name cannot include '\u0001' or newline characters. 
 */

    public String
    getName() {
        if (SharedDataObserverImpl_Debug) {
            System.out.println("SharedDataObserverImpl: getName: " + name);
        }
        return(name);
    }
}
