// Copyright (c) 1996-98 The Regents of the University of California. All
// Rights Reserved. Permission to use, copy, modify, and distribute this
// software and its documentation for educational, research and non-profit
// purposes, without fee, and without a written agreement is hereby granted,
// provided that the above copyright notice and this paragraph appear in all
// copies. Permission to incorporate this software into commercial products may
// be obtained by contacting the University of California. David F. Redmiles
// Department of Information and Computer Science (ICS) University of
// California Irvine, California 92697-3425 Phone: 714-824-3823. This software
// program and documentation are copyrighted by The Regents of the University
// of California. The software program and documentation are supplied "as is",
// without any accompanying services from The Regents. The Regents do not
// warrant that the operation of the program will be uninterrupted or
// error-free. The end-user understands that the program was developed for
// research purposes and is advised not to rely exclusively on the program for
// any reason. IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY
// PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES,
// INCLUDING LOST PROFITS, ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS
// DOCUMENTATION, EVEN IF THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF THE
// POSSIBILITY OF SUCH DAMAGE. THE UNIVERSITY OF CALIFORNIA SPECIFICALLY
// DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE
// SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
// CALIFORNIA HAS NO OBLIGATIONS TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
// ENHANCEMENTS, OR MODIFICATIONS.

// File: ActionScroll.java
// Classes: ActionSroll
// Original Author: jrobbins@ics.uci.edu
// $Id: ActionScroll.java,v 1.3 1997/06/10 23:42:20 jrobbins Exp $

package uci.graphedit;

import java.util.*;
import java.awt.*;

/** Action scroll the view.  Needs-More-Work: not implemented yet.  */

public class ActionScroll extends Action {
  ////////////////////////////////////////////////////////////////
  // constants

  public static final int LEFT = 1;
  public static final int RIGHT = 2;
  public static final int UP = 3;
  public static final int DOWN = 4;

  ////////////////////////////////////////////////////////////////
  // instance variables

  private int _direction;
  private int _magnitude;

  ////////////////////////////////////////////////////////////////
  // constructor

  public ActionScroll(int dir) {
    _direction = dir;
    _magnitude = 16; // Needs-More-Work: prefs
    }

  /** Scroll the view of the current editor in the given direction.
   *  Needs-More-Work: not implemented yet.  */
  public void doIt(Event e) {
      int deltaX = 0, deltaY = 0;
      // Needs-More-Work
      switch (_direction) {
        case LEFT: deltaX = _magnitude; break;
        case RIGHT: deltaX = 0 - _magnitude; break;
        case UP: deltaY = _magnitude; break;
        case DOWN: deltaY = 0 - _magnitude; break;
      }
      // Needs-More-Work: now do something with deltas...
      System.out.println("Scrolling by " + deltaX + ", " + deltaY);
  }

  public void undoIt() {
    System.out.println("Cannot undo ActionScroll, yet.");
  }

} /* end class ActionScroll */
