// Copyright (c) 1996-98 The Regents of the University of California. All
// Rights Reserved. Permission to use, copy, modify, and distribute this
// software and its documentation for educational, research and non-profit
// purposes, without fee, and without a written agreement is hereby granted,
// provided that the above copyright notice and this paragraph appear in all
// copies. Permission to incorporate this software into commercial products may
// be obtained by contacting the University of California. David F. Redmiles
// Department of Information and Computer Science (ICS) University of
// California Irvine, California 92697-3425 Phone: 714-824-3823. This software
// program and documentation are copyrighted by The Regents of the University
// of California. The software program and documentation are supplied "as is",
// without any accompanying services from The Regents. The Regents do not
// warrant that the operation of the program will be uninterrupted or
// error-free. The end-user understands that the program was developed for
// research purposes and is advised not to rely exclusively on the program for
// any reason. IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY
// PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES,
// INCLUDING LOST PROFITS, ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS
// DOCUMENTATION, EVEN IF THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF THE
// POSSIBILITY OF SUCH DAMAGE. THE UNIVERSITY OF CALIFORNIA SPECIFICALLY
// DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE
// SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
// CALIFORNIA HAS NO OBLIGATIONS TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
// ENHANCEMENTS, OR MODIFICATIONS.

// File: ActiveButton.java
// Classes: ActiveButton
// Original Author: jrobbins@ics.uci.edu
// $Id: ActiveButton.java,v 1.6 1997/06/10 23:42:28 jrobbins Exp $

package uci.graphedit;

import java.util.*;
import java.awt.*;

/** An ActiveComponent for a Button. It stores an AWT button and a
 *  uci.graphedit.Action. When the button is pressed, the Action is
 *  performed. Client Frames must still process events and find when
 *  Active component should handle a given event. <p>
 *
 *  Needs-More-Work: This may be deleted in a future release.
 *
 * @see Action
 * @see PaletteFig */

public class ActiveButton extends ActiveComponent  {

  /** The AWT button */
  private Button _button;

  /** The uci.graphedit.Action to be exectuted */
  private Action _action;

  /** Construct a new ActiveButton.
   * @param label The String to be shown on the button.
   * @param act   The Action to be exectuted when the button is pressed.
   */
  public ActiveButton(String label, Action act) {
    _button = new java.awt.Button(label);
    _action = act;
  }

  public Component component() { return _button; }
  public Action action() { return _action; }

  // public void doIt(java.awt.Event e) { action().doIt(e); }
  public void undoIt() { action().undoIt(); }

} /* end class ActiveButton */

