// Copyright (c) 1996-98 The Regents of the University of California. All
// Rights Reserved. Permission to use, copy, modify, and distribute this
// software and its documentation for educational, research and non-profit
// purposes, without fee, and without a written agreement is hereby granted,
// provided that the above copyright notice and this paragraph appear in all
// copies. Permission to incorporate this software into commercial products may
// be obtained by contacting the University of California. David F. Redmiles
// Department of Information and Computer Science (ICS) University of
// California Irvine, California 92697-3425 Phone: 714-824-3823. This software
// program and documentation are copyrighted by The Regents of the University
// of California. The software program and documentation are supplied "as is",
// without any accompanying services from The Regents. The Regents do not
// warrant that the operation of the program will be uninterrupted or
// error-free. The end-user understands that the program was developed for
// research purposes and is advised not to rely exclusively on the program for
// any reason. IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY
// PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES,
// INCLUDING LOST PROFITS, ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS
// DOCUMENTATION, EVEN IF THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF THE
// POSSIBILITY OF SUCH DAMAGE. THE UNIVERSITY OF CALIFORNIA SPECIFICALLY
// DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE
// SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
// CALIFORNIA HAS NO OBLIGATIONS TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
// ENHANCEMENTS, OR MODIFICATIONS.

// File: SamplePalette.java
// Classes: SamplePalette
// Original Author: jrobbins@ics.uci.edu
// $Id: SamplePalette.java,v 1.7 1997/06/10 23:40:36 jrobbins Exp $

package uci.graphedit.demo;

import java.awt.*;
import java.util.*;
import uci.graphedit.*;

/** A class to define the left hand column of buttons in the Example
 * application. Right now it just has one kind of node.
 *
 * @see uci.graphedit.demo.FlexibleApplet */

public class SamplePalette extends Palette {

  /** The class for the NetNode's to make when the user clicks the
   * SampleNode button. */
  static final String SampNode1CLASS = "uci.graphedit.demo.SampleNode";
  static final String SampNode2CLASS = "uci.graphedit.demo.SampleNode2";
  static final String SampNode3CLASS = "uci.graphedit.demo.SampleNode3";

  /** Construct a new palette of example nodes for the Example application */
  public SamplePalette() { super(2, 1, "Example"); }

  /** Define a button to make for the Example application */
  public Vector defineButtons() {
    Vector v = new Vector();
    Action addSampNode1 = new ActionCreateNode(SampNode1CLASS, null, false);
    v.addElement(new ActiveButton("Node One", addSampNode1));
    Action addSampNode2 = new ActionCreateNode(SampNode2CLASS, null, false);
    v.addElement(new ActiveButton("Node Two", addSampNode2));
    return v;
  }

} /* end class SamplePalette */
