// Copyright (c) 1996-98 The Regents of the University of California. All
// Rights Reserved. Permission to use, copy, modify, and distribute this
// software and its documentation for educational, research and non-profit
// purposes, without fee, and without a written agreement is hereby granted,
// provided that the above copyright notice and this paragraph appear in all
// copies. Permission to incorporate this software into commercial products may
// be obtained by contacting the University of California. David F. Redmiles
// Department of Information and Computer Science (ICS) University of
// California Irvine, California 92697-3425 Phone: 714-824-3823. This software
// program and documentation are copyrighted by The Regents of the University
// of California. The software program and documentation are supplied "as is",
// without any accompanying services from The Regents. The Regents do not
// warrant that the operation of the program will be uninterrupted or
// error-free. The end-user understands that the program was developed for
// research purposes and is advised not to rely exclusively on the program for
// any reason. IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY
// PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES,
// INCLUDING LOST PROFITS, ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS
// DOCUMENTATION, EVEN IF THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF THE
// POSSIBILITY OF SUCH DAMAGE. THE UNIVERSITY OF CALIFORNIA SPECIFICALLY
// DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE
// SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
// CALIFORNIA HAS NO OBLIGATIONS TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
// ENHANCEMENTS, OR MODIFICATIONS.

// File: SamplePort2.java
// Classes: SamplePort2
// Original Author: ics125b spring 1996
// $Id: SamplePort2.java,v 1.2 1997/06/10 23:40:38 jrobbins Exp $

package uci.graphedit.demo;

import java.awt.*;
import java.util.Vector;
import java.io.*;
import uci.graphedit.*;

/** An example subclass of NetPort for the Example application. As
 * part of the example I constrain the ports to only be on
 * SampleNode's and only connect to SamplePort2's. Needs-More-Work:
 * There should be a way to constrain the type of NetArc that is
 * used...
 *
 * @see Example */

public class SamplePort2 extends SamplePort {

   /** Construct a new SamplePort2 as a port of the given NetNode. This
    * example includes the constraint that SamplePort2's can only be
    * part of SampleNode's. */
   SamplePort2(NetNode parent) {
     super(parent);
     if (!(parent instanceof SampleNode)) {
       // throw an exception
       System.out.println("SamplePort2s are only to be used on SampleNodes");
     }
   }

  protected Class defaultArcClass(NetPort otherPort) {
    try { return Class.forName("uci.graphedit.demo.SampleArc2"); }
    catch (java.lang.ClassNotFoundException ignore) { return null; }
  }


  /** Add the constraint that SamplePort2's can only be connected to
   * other ports of the same type. */
  public boolean canConnectTo(NetPort anotherPort) {
    return (super.canConnectTo(anotherPort)) &&
      (anotherPort.getClass() == this.getClass());
    // needs-more-work: should work with subclasses too. This is
    // really a java.lang.Class method that is missing: isSubclass()
  }

} /* end class SamplePort2 */
