// Copyright (c) 1996-98 The Regents of the University of California. All
// Rights Reserved. Permission to use, copy, modify, and distribute this
// software and its documentation for educational, research and non-profit
// purposes, without fee, and without a written agreement is hereby granted,
// provided that the above copyright notice and this paragraph appear in all
// copies. Permission to incorporate this software into commercial products may
// be obtained by contacting the University of California. David F. Redmiles
// Department of Information and Computer Science (ICS) University of
// California Irvine, California 92697-3425 Phone: 714-824-3823. This software
// program and documentation are copyrighted by The Regents of the University
// of California. The software program and documentation are supplied "as is",
// without any accompanying services from The Regents. The Regents do not
// warrant that the operation of the program will be uninterrupted or
// error-free. The end-user understands that the program was developed for
// research purposes and is advised not to rely exclusively on the program for
// any reason. IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY
// PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES,
// INCLUDING LOST PROFITS, ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS
// DOCUMENTATION, EVEN IF THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF THE
// POSSIBILITY OF SUCH DAMAGE. THE UNIVERSITY OF CALIFORNIA SPECIFICALLY
// DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE
// SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
// CALIFORNIA HAS NO OBLIGATIONS TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
// ENHANCEMENTS, OR MODIFICATIONS.

// File: DebugLog.java
// Class: DebugLog
// Original Author: jrobbins@ics.uci.edu
// $Id: DebugLog.java,v 1.6 1997/06/10 23:30:56 jrobbins Exp $

package uci.util;

/** This is a useful utility for debugging. In various places in the
 *  framework there are calls to DebugLog.log(). If the proper -D
 *  defines are supplied when running the application those debugging
 *  statements will be enabled or disabled. */

public class DebugLog {

  /** Print the given message if the guard was defined with a command
   *  line -D option. */
  public static final void log(String guard, String msg) { 
    if (Boolean.getBoolean(guard)) System.out.println(msg);
  }

  /** Print the given message if the guard was defined with a command
   *  line -D option and the given condition evaluates to true. */
  public static final void log(String guard, boolean cond, String msg) {
    if (Boolean.getBoolean(guard) && cond) System.out.println(msg);
  }

} /* end class DebugLog */
