package webflow.appletsocket;

import java.io.*;
import java.net.*;
import java.lang.*;

public class PortServer implements Runnable{
 
Socket socket;
ServerSocket ss;

private Thread runner;

String m1,m2,m3;
int port;
Integer p;


  /* The big idea is as follows:
     module creates a server socket and sends its port number here (p)
     (message with format PUTX, where X is the port number)
     then the controls connect with message GET which is responded to by
     sending the value of p (converted to a a string).
     Now, it may happen that the controls connects before the module,
     therefore p is initialised to 0, and reset to 0 as soon as it is sent.
     This way p=0 unless the module deposited a new port number.
     Controls is supposed to keep trying till p != 0, therefore connection
     is implemented as a separate thread.
     This servr is implemented as a separate thread in order not to block
     WebEdit.
     In the future, this server should be moved to the backend
     */

public PortServer() {

try{
   ss=new ServerSocket(5500);
   }
catch(IOException e) {System.out.println(e);}

 p = new Integer(0);
 start();
}

public void start()
{
    if(runner==null)
{
   runner= new Thread(this);
   runner.start();
}
}

  public void run(){

    while(true) {
	  try {
           socket=ss.accept();
           Connection c = new Connection(socket);
          }
	  catch (IOException e) {System.out.println(e.toString());}
    }
  }

  class Connection extends Thread {
    protected Socket client;
    protected DataInputStream dis;
    protected DataOutputStream dos;

  public Connection(Socket client_socket) {
  client = client_socket;
  try {
           dos= new DataOutputStream(client_socket.getOutputStream());
           dis= new DataInputStream(client_socket.getInputStream());
  }
  catch (IOException e) {
         try {client.close();}
         catch (IOException e2) {;}
         System.err.println("Exception while getting socket streams: " + e);
         return;
  }
  this.start();
  }
  
  public void run() {

	   String message = receive();
           if(message.startsWith("PUT")) {
              m1 = message.substring(3);
              System.out.println("register port "+m1); 
              p = new Integer(m1);
              port = p.intValue(); 
	   }
	   else {
	     if(message.startsWith("GET")) {
             send(p.toString());
             p = new Integer(0);             
	     }
	     else{
                System.out.println("unknown request to the PortServer");
	     }
	   }
          {try {socket.close();}  catch (IOException e2) {;}}	
  }

  public void send(String message){

     int sl = message.length();
     byte[] buf =new byte[sl];
     message.getBytes(0,sl,buf,0); 
     System.out.println("Trying to send... "+message);

       try{
           dos.writeInt(sl);
           dos.write(buf,0,sl);
           dos.flush();
          } catch(IOException e) {System.out.println(e);}
}

     public String receive(){
     String message = "";
     try{
        int ls=dis.readInt();
        byte buf[] = new byte[ls];
        dis.read(buf,0,ls);
        message = new String(buf,0,ls);
	//        System.out.println("I have received from Applet: "+message);
        } catch(IOException e){
          System.out.println(e);
          stop();
        }
    return(message);
    }

  }  
    
  public void stop(){
System.out.println("stopping PortServer");
    if(runner!=null){
runner.stop();
runner=null;
try{
socket.close();
}catch(IOException e) {System.out.println(e);}
    }
  }
}




























