package webflow.backend;

import java.net.ServerSocket;

/**
* interface Module will be implemented by all the 'modules' in the 
* system. All the user code goes into a class that implements the
* module interface
*/
public interface Module {

  /** 
  * initialize the module, put all module information in a 
  * MetaModule, and return that information. 
  */
  public MetaModule initialize();
 
  /**
  * run the module code
  */ 
  public void run();

  /** 
  * stop the execution of the module. 
  */
  public void stop();

  /**
  * deallocate all resources allocated by the module. Destroy the module
  */
  public void destroy();

  /**
  *
  public ServerSocket getSocket();
  */
}
