
package webflow.backend.WFSession;

import java.net.*;
import java.io.*;
import java.util.*;

import webflow.backend.*;
import webflow.frontend.*;
import webflow.util.Action;

/**
*/
public class
ServiceAllModules extends SessionServices
                        implements webflow.util.Action, WebFlowDebugFlags
{

  /** Operation code */
  private int OpCode = MMrequest.RUN;

  /**
  */
  public
  ServiceAllModules(WFlowSession _mySession, int _OpCode)
  { 
     super(_mySession);

     if( _OpCode == MMrequest.RUN || 
         _OpCode == MMrequest.STOP ||
         _OpCode == MMrequest.DESTROY ) OpCode = _OpCode;
 
  }// end of constructor

  /**
  * 
  * <ol>
  *  <li> Accepts the connection request from client.
  *  <li> Sends the SMreply to the client and waits for the acknowledge. 
  *  <li> Stop.
  * </ol>
  */
  public void
  //run()
  service()
  { 
    clientSocket = null;

    /** Accept client connection */
    if(acceptConnection()<0) return;
    Diagnostic diag = mySession.getDiagnostic();


    SMreply rett = new SMreply(SMreply.ERROR,"Unknown");

    boolean allSucceeded = true;

    try
    {
      Enumeration keys = mySession.getModuleTable().keys();

      /** for each of the elements in the proxy module list  */
      while( keys.hasMoreElements() && ( allSucceeded == true ) )
      {
        /** get the actual key, and retrieve its module representation */
        ID moduleID = (ID) keys.nextElement();
        ModuleRepresentation mr = mySession.getModuleRepWithID( moduleID ); 

        /** open a socket towards the corresponding module manager */
        Socket s = new Socket(mr.getHostName(),mr.getModuleManagerPort());

        /** and send a request to stop the module */
        MMrequest req = new MMrequest(OpCode, moduleID);
        req.toStream(s.getOutputStream());

        /** wait for a reply */
        MMreply reply = new MMreply();
        reply.fromStream(s.getInputStream());

        /** and if an error occured */
        if (reply.getStatus()== MMreply.ERROR) 
        {  
           allSucceeded = false;
           rett = new SMreply(SMreply.ERROR, reply.getDescription());

        }// end of if

        /** close the socket */
        s.close();

      }// end of while


    } /** in case an exception occurs, for now, just ignore the     */
      /** started modules, and send an 'error occured' message back */
      catch(IOException e1)
      {  rett = new SMreply(SMreply.ERROR,
             "Exception raised while trying to run");
      }
      catch(Exception e)
      {  diag.write("wierd exception raised");
         diag.write("Exception " + e);
         rett = new SMreply(SMreply.ERROR,
             "Exception raised while trying to run");
      }

    if(allSucceeded == true ) rett = new SMreply(SMreply.OK);

    sendMessage( rett );


  }// end of run


}// end of class SessionServices

