
package webflow.backend.WFSession;

import java.net.*;
import java.io.*;
import java.util.*;

import webflow.backend.*;
import webflow.frontend.*;
import webflow.util.Action;


/**
*/
public class
ServiceConnect extends SessionServices
               implements webflow.util.Action, WebFlowDebugFlags
{
  /** Name of the Module */
  private  ID from;
  private  ID to;
  private  ID mIDfrom;
  private  ID mIDto;

  /**
  */
  public
  ServiceConnect(ID _from, ID _to, ID _mIDfrom, ID _mIDto, 
                 WFlowSession _mySession)
  { 
     super(_mySession);
     from = _from;
     to   = _to;
     mIDfrom = _mIDfrom;
     mIDto   = _mIDto;
 
  }// end of constructor

  /**
  * 
  * <ol>
  *  <li> Accepts the connection request from client.
  *  <li> Sends the SMreply to the client and waits for the acknowledge. 
  *  <li> Stop.
  * </ol>
  */
  public void
  //run()
  service()
  { 
    clientSocket = null;

    /** Accept client connection */
    if(acceptConnection()<0) return;

    SMreply rett = new SMreply( SMreply.ERROR , "Unknown!" );

    /** get the module representations for the two moduleIDs */
    ModuleRepresentation mrFrom =  mySession.getModuleRepWithID(mIDfrom);
    ModuleRepresentation mrTo = mySession.getModuleRepWithID(mIDto);
    Diagnostic diag = mySession.getDiagnostic();

    diag.write("from host "+mrFrom.getHostName()+" "+"port ="+mrFrom.getConnectionManagerPort());
    diag.write("to host "+ mrTo.getHostName()+"port ="+mrTo.getConnectionManagerPort());

    try
    {
      /** open a connection and send a request to a connection manager     */
      /** (i.e. to the connection manager on which the 'from' port resides */
      Socket socket = new Socket(mrFrom.getHostName(),
                 mrFrom.getConnectionManagerPort());
      CMrequest req = new CMrequest(CMrequest.ESTABLISH, from, to,
                    mrTo.getHostName(),"here",
                    mrTo.getConnectionManagerPort(),0);
      req.toStream(socket.getOutputStream());

      /** receive the reply */
      CMreply reply = new CMreply();

      reply.fromStream(socket.getInputStream());

      switch(reply.getStatus())
      { case CMreply.ERROR : 
             rett = new SMreply(SMreply.ERROR, reply.getDescription()) ;
             break;
        case CMreply.OK    :
             rett = new SMreply(SMreply.OK) ;
             break;
        default :
             rett = new SMreply(SMreply.ERROR, " Unknown ") ;
      }// end of switch()

      socket.close();

    } /** do nothing, i.e. return a null SMreply */
      catch(IOException ioe) 
      {  System.out.println("IOException in newModule() ");
         ioe.printStackTrace();
         rett = new SMreply( SMreply.ERROR, " IOException in newModule() " ) ;
      }

    sendMessage( rett );

  }// end of run


}// end of class SessionServices

