
package webflow.backend.WFSession;

import java.net.*;
import java.io.*;
import java.util.*;

import webflow.backend.*;
import webflow.frontend.*;
import webflow.util.Action;


/**
*/
public class
ServiceNewModule extends SessionServices
                 implements webflow.util.Action, WebFlowDebugFlags
{
  /** Name of the Module */
  private  String ModuleName;

  /**
  */
  public
  ServiceNewModule(String _moduleName, WFlowSession _mySession)
  { 
     super(_mySession);
     ModuleName = new String(_moduleName);
 
  }// end of constructor

  /**
  * 
  * <ol>
  *  <li> Accepts the connection request from client.
  *  <li> Gets the <b>servername</b> from the session.
  *  <li> Makes connection with MM and CM 
  *  <li> Asks MM to initialize the given module
  *  <li> If the reply from MM is OK, then
  *   <ol>
  *    <li> Asks session object to add this module.
  *    <li> Prepare the SMreply according to the prevrious result.
  *   </ol>
  *  <li> Sends the SMreply to the client and waits for the acknowledge. 
  *  <li> Stop.
  * </ol>
  */
  public void
  //run()
  service()
  { 
    clientSocket = null;

    /** Accept client connection */
    if(acceptConnection()<0) return;

    /** */
    String serverName = mySession.getServerNameFor(ModuleName);
    
    /** find the socket addresses of the ModuleManager */
    /** and ConnectionManager on that server           */
    String hostName = null;
    int MMportNumber = 0;
    int CMportNumber = 0;
    String htmlString= null ;
    String MMurl = "http://" + serverName + "/servlet/modulemanager";
    String CMurl = "http://" + serverName + "/servlet/connectionmanager";
    SMreply rett = new SMreply(SMreply.ERROR,"Unknown!");
    Diagnostic diag = mySession.getDiagnostic();

    if(DEBUG==true)
    {
       System.out.println("MMurl : "+MMurl);
       System.out.println("CMurl : "+CMurl);
    }

    try 
    {
      ServerAddress MMaddress = new ServerAddress(MMurl);
      ServerAddress CMaddress = new ServerAddress(CMurl);
      hostName = MMaddress.getHostName();
      MMportNumber = MMaddress.getPortNumber();
      CMportNumber = CMaddress.getPortNumber();

      if(DEBUG==true)
      { 
         System.out.println("I got the Managers alright ");
         System.out.println("hostName : "+hostName );
      }

      /** after the socket addresses are found, */
      /** make an MMrequest, and send it        */
      /** to the ModuleManager                  */
      Socket toMM = new Socket(hostName, MMportNumber);
      InputStream in = toMM.getInputStream();
      OutputStream out= toMM.getOutputStream();

      if(DEBUG==true)
         System.out.println("I got the sockets  alright ");

      diag.write("sending request to " + MMurl);

      MMrequest request = new MMrequest(MMrequest.INITIALIZE, ModuleName);
      request.toStream(out);

      if(DEBUG==true)
         System.out.println("I send the request  ");

      /** receive the MMreply from the ModuleManager */
      MMreply reply = new MMreply();

      if(reply.fromStream(in)) 
      {

         /** If there is no ERROR */
         if( reply.getStatus() != MMreply.ERROR)
         {
            Vector response = 
                            mySession.addModuleToTable( reply.getMetaModule(), hostName, 
                                              serverName, MMportNumber, CMportNumber );
            
            /** Let's decode the return values */
            htmlString = (String) response.elementAt(0);
            Vector portStorage = (Vector) response.elementAt(1);
            int htmlKey = ((Integer) response.elementAt(2)).intValue();

            /** and finally, create a reply */
            if(htmlString == null)
               rett = new SMreply( SMreply.OK, reply.getMetaModule().getModuleID() , 
                                   portStorage);
            else
               rett = new SMreply( SMreply.HTML, reply.getMetaModule().getModuleID(), 
                                   portStorage, htmlKey, 
                                   reply.getMetaModule().getViewerWinName());

            diag.write("reply composed");
            if(DEBUG==true)
               System.out.println("reply composed");
      
         } else rett = new SMreply(SMreply.ERROR, reply.getDescription() );

      } else rett = new SMreply( SMreply.ERROR , "I/O Problem" );

    } /** do nothing, i.e. return a null SMreply */
      catch(IOException ioe) 
      {  System.out.println("IOException in newModule() ");
         ioe.printStackTrace();
         rett = new SMreply(SMreply.ERROR," IOException in newModule() ") ;
      }

    sendMessage( rett );

  }// end of run


}// end of class SessionServices

