
package webflow.frontend;

import java.lang.*;
import java.util.*;
import uci.graphedit.*;
import webflow.backend.*;


/** 
 
  Action
   |
   +----------------+
                    |
	       ActionDestroy
  ______________________________________________________________________
    
  Destroys all the created modules.
       
*/
public class ActionDestroy extends Action {

  /** Private member. Stores a reference to the parent editor */
  WebEditor editor;

  /** Constructs an action Destroy */
  public ActionDestroy ( Editor e){

    editor = (WebEditor)e;
    
  }
 
  /** executes the action Destroy */
  public void doIt(java.awt.Event e) {
    // sends the message SMrequest and waits for reply
    SMreply reply = editor.destroy();

    // check the reply status
    if( reply.getStatus() == SMreply.OK ){

      // remove the modules from the editor stucture 
      editor.view().removeAll(); 
//      editor.view().findLayerNamed("LayerOne").removeAll();
      editor.damageAll();
      editor.repairDamage(); // repaint
 
    }
    else {
	System.out.println("ActionDestroy: SMreply status = " 
		+ reply.getStatus());
    }
      
  }



  public void undoIt() {
    System.out.println("undo is not implemented");
  }


} /* end class ActionCreateNode */





