package webflow.frontend.WFtree;

import java.lang.*;
import java.util.*;
import java.awt.*;

/**
*
* @date August 1997, ( Updated at: November 3, 1997)
* @author H. Timucin Ozdemir ( timucin@npac.syr.edu )
*
*/
public
class ScrollableTreeViewPanel extends Panel 
                              implements ScrollerInterface 
{
  Scrollbar vscroller = null  ; 
  Scrollbar hscroller = null  ; 
  Dimension dim;
  public TreeViewPanel view; 
  TreeNode root;
  
  public ScrollableTreeViewPanel(TreeNode _root,int wid,int hei, Frame _const) 
  {
    dim = new Dimension(wid,hei);
    setLayout(new BorderLayout());

    root = _root;

    view = new TreeViewPanel(root,this,wid-25,hei,_const);
    //view.startObserving();
    add("West",view);
   
    vscroller=new Scrollbar(Scrollbar.VERTICAL);
    add("East",vscroller);
 
    hscroller=new Scrollbar(Scrollbar.HORIZONTAL);
    add("South",hscroller);
    validate();
  }

  public void
  setFrame(Frame _myFrame)
  {  if(_myFrame!=null) view.setFrame(_myFrame); }

  public int getVerticalScrollerVal() {
    return vscroller.getValue();
  }
  
  public int getVerticalScrollerVis() {
    return vscroller.getVisible();
  }
  
  public int getVerticalScrollerMin() {
    return vscroller.getMinimum();
  }
  
  public int getVerticalScrollerMax() {
    return vscroller.getMaximum();
  }
  
  public void setVerticalScrollerValues(int val,int vis,int min,int max) {
    vscroller.setValues(val,vis,min,max);
  }
  
  public int getHorizontalScrollerVal() {
    return hscroller.getValue();
  }
  
  public int getHorizontalScrollerVis() {
    return hscroller.getVisible();
  }
  
  public int getHorizontalScrollerMin() {
    return hscroller.getMinimum();
  }
  
  public int getHorizontalScrollerMax() {
    return hscroller.getMaximum();
  }
  
  public void setHorizontalScrollerValues(int val,int vis,int min,int max) {
    hscroller.setValues(val,vis,min,max);
  }
  
  public boolean handleEvent(Event evt) {
    if ((evt.id==Event.SCROLL_LINE_DOWN) || 
	(evt.id==Event.SCROLL_LINE_UP) || 
	(evt.id==Event.SCROLL_PAGE_DOWN) || 
	(evt.id==Event.SCROLL_PAGE_UP) ||
	(evt.id==Event.SCROLL_ABSOLUTE)) {
      view.repaint();
      return true;
    }
    return false;
  }
  
  public Dimension preferredSize() 
  {
    Dimension viewdim = view.updateSize();
    Dimension ret = new Dimension( Math.max( dim.width,  viewdim.width+10 ) ,
                                   Math.max( dim.height, viewdim.height+10 ) );

    System.out.println("ScrollableTreeViewPanel::preferredSize() is "+ret);
    
    return ret;

  }// end of preferredSize()

  public Point
  getScrollPosition()
  { return new Point(hscroller.getValue(),vscroller.getValue()); }

  /** Handles the mouseUp/Down Events */
  public void
  doIt(java.awt.Event evt)
  {
    switch(evt.id)
    { 
      case Event.MOUSE_UP : view.mouseUp(evt,evt.x,evt.y);
                            break;

      case Event.MOUSE_DOWN : view.mouseDown(evt,evt.x,evt.y);
                              break;
    }// end of switch()

  }// end of doIt()

  public void
  undoIt()
  { }

  /**
  * Repaint the Tree
  */
  public void
  refresh(TreeNode _root)
  {  
     root = _root;
     view.setRoot(_root);
  }

}// end of  class ScrollableTreeViewPanel


