
package webflow.frontend;

import uci.graphedit.*;
import webflow.backend.SMreply;

/**
* This object overwrites the connect() method of 
* NetArc so that it can chekcs whether two port
* can be connected on the Server Side also. 
*/
public class
WebArc extends NetArc
       implements UserInterfaceDebug
{

   /**
   */
   public 
   WebArc() 
   { super();}

   /**
   */
   public ArcPerspective 
   makePerspective(uci.graphedit.Layer lay) 
   { 
      if( DEBUG == true )
          System.out.println(" I am in makePerspective of WebArc ");

      //return new ArcPerzLine(); 
      
      return new WebArcPerspective(this);

   }// end of makePerspective()

   public boolean
   connect(NetPort src, NetPort dst)
   {
      boolean ret = super.connect(src,dst);

      /**********************************************/
      /** If super.connect() returns OK, then let's */
      /** Look at the connection on the server side */
      /** If it is posiible, then we return true    */
      /**********************************************/
      if(ret == true)
      {
        if( DEBUG == true) 
            System.out.println("In Connect of WebArc ");
        
        SMreply reply = null;

        /**********************************************/
        /** Let's check the object types to make sure */
        /** everything comes as expected.             */
        /**********************************************/
        if( ( src instanceof WebPort ) && 
            ( dst instanceof WebPort ) && 
            ( Globals.curEditor() instanceof WebEditor) ) 
        {  
           WebPort startPort = (WebPort) src;
           WebPort foundPort = (WebPort) dst;
           reply = ((WebEditor)Globals.curEditor()).connect( startPort.getID(), foundPort.getID(),
                                             ((WebNode)startPort.parentNode()).getID(),
                                             ((WebNode)foundPort.parentNode()).getID() );
        }// end of if

        /********************************************************/
        /** If rempl is not null and the Operation status is OK */
        /** Connection is granted for the visual effects also   */
        /********************************************************/
        ret = ( reply != null && reply.getStatus() == SMreply.OK);

      }// end of if

      return ret;
      
   }// end of connect()
  
}// end of class WebArc

