package webflow.frontend;


import java.awt.*;
import java.io.*;
import uci.graphedit.*;

/** 
* An example subclass of NetNode for use in the Example application.
*
*/
public class 
WebNode1 extends WebNode 
{


  /**
  * Overwrite
  */
  public void 
  initialize(NetNode deft, Object model) 
  { 

     /***********************************************************/
     /** updates the module info of this node                   */
     /** ActionCreateWebNode sets the ModuleTree.currentItem    */
     /** and then calls the doIt() method of ActionCreateNode   */
     /** in this method control comes back initialize() method  */
     /** of the NetNode object so that we can update the module */
     /** info of our WebNode object.                            */ 
     /***********************************************************/
     setModuleTreeItem(ModuleTree.currentItem);

     portList = new WebPort[4];
     numPorts = 4;
     portList[0] = new WebPort(this, "int");
     portList[1] = new WebPort(this, "int");
     portList[2] = new WebPort(this,"int");
     portList[3] = new WebPort(this, "int");

  }// end of initialize()

  /**
  * Overwrite
  */
  public Perspective 
  makePerspective(Layer lay) 
  {
      Fig obj1 = new FigRect(-20, -20, 60, 40, Color.red, Color.black);
      FigList temp_list = new FigList();

      temp_list.addFig(obj1);
      
      Fig obj3 = new FigRect(-15, -25, 10, 10, Color.black, Color.cyan);
      Fig obj4 = new FigRect( 5,  -25, 10, 10, Color.black, Color.orange);
      Fig obj5 = new FigRect(25,  -25, 10, 10, Color.black, Color.green);
    
      Fig obj6 = new FigCircle( 5, 15, 10, 10, Color.black, Color.red);

      temp_list.addFig(obj3);
      temp_list.addFig(obj4);
      temp_list.addFig(obj5);
      temp_list.addFig(obj6);
  

      WebPerspective pers1 = new WebPerspective(this, temp_list);

      pers1.addPort(portList[0], obj3, 1);
      pers1.addPort(portList[1], obj4, 1);
      pers1.addPort(portList[2], obj5, 1);
      pers1.addPort(portList[3], obj6, 3);
    
      return pers1;
     
   }// end of makePerspective()


}// end class WebNode1.java 
