
package webflow.frontend;


import java.awt.*;
import java.io.*;
import java.util.*;
import uci.graphedit.*;

/** An example subclass of NetNode for use in the Example application.
*
*/
public class 
WebNodeImgF extends WebNode 
{
   static Hashtable colorTable = new Hashtable();

   static 
   {
   	colorTable.put("FlipFilter",	new Color(255,255,0));
	colorTable.put("BleachFilter",	new Color(0,255,255));
   }

  public void 
  initialize(NetNode deft, Object model) 
  {
     /***********************************************************/
     /** updates the module info of this node                   */
     /** ActionCreateWebNode sets the ModuleTree.currentItem    */
     /** and then calls the doIt() method of ActionCreateNode   */
     /** in this method control comes back initialize() method  */
     /** of the NetNode object so that we can update the module */
     /** info of our WebNode object.                            */
     /***********************************************************/
     setModuleTreeItem(ModuleTree.currentItem);

     portList = new WebPort[2];
     numPorts = 2;
     portList[0] = new WebPort(this, "img");
     portList[1] = new WebPort(this, "img");

  }// end of initialize()    

  /**
  * Overwrite
  */
  public Perspective 
  makePerspective(Layer lay)
  {

      int FontSize = 12;
      Font myLabelFont = new Font("TimesRoman",Font.PLAIN,FontSize);
      FontMetrics myLabelFontMetrics = Toolkit.getDefaultToolkit().getFontMetrics(myLabelFont);

      int TextWidth = myLabelFontMetrics.stringWidth(mli.getClassLabel())+5;
      int TextHeight = myLabelFontMetrics.getHeight()+5;
 
      /** label of the Visual Representation */
      Fig obj0 = new FigText(-10, -10, TextWidth, TextHeight, 
                              Color.white, "TimesRoman", FontSize);

      ((FigText)obj0).setText(mli.getClassLabel());

      Color color = (Color)colorTable.get(mli.getClassLabel());

      if(color == null) { color = Color.pink; }

      /** A Big Circle which includes everything */
      Fig obj1 = new FigCircle(-20, -20, TextWidth+20, TextHeight+20, 
                               Color.black, color);
      FigList temp_list = new FigList();

      temp_list.addFig(obj1);
      temp_list.addFig(obj0);

      /** Ports. */
      Fig obj2 = new FigArc1(-25, -1*(TextHeight/2), 20, 20, Color.red, new Color(240, 80, 255)
			    , 140, 80);

      Fig obj3 = new FigCircle(TextWidth-5, -1*(TextHeight/2)+5, 10, 10, Color.red, 
			       new Color(240, 80, 255));
    
      temp_list.addFig(obj2);
      temp_list.addFig(obj3);
      

      WebPerspective pers1 = new WebPerspective(this, temp_list);

      pers1.addPort(portList[0], obj3, 4);
      pers1.addPort(portList[1], obj2, 2);
   
      return pers1;
     
   }// end of makePerspective()


}// end class WebNodeImgH.java 
