
package webflow.frontend;

import java.awt.*;
import java.util.*;
import java.io.*;
import uci.graphedit.*;

/** Class to display graphics for NetNode's */

public class WebPerspective extends Perspective {
  
  Vector sectors;
  
   /**  Constructs a new Perspective on the given NetNode with the
   *  given Fig's. */
  public WebPerspective(NetNode parent_node, FigList figs) {
    super(parent_node, figs);
    sectors = new Vector();
  }


  /**  Adds a port into the current perspective */
  public void addPort(NetPort prt, Fig rep, int sect) {
    super.addPort(prt,rep);
    sectors.addElement( new Integer(sect) );
  }

  /** Removes a port from the current perspective */
  public void removePort(Fig rep) {
    sectors.removeElementAt( portList.indexOf( rep));
    super.removePort(rep);
  } 

  public int portSector(NetPort rep){ 
    return ((Integer)sectors.elementAt( portList.indexOf(rep))).intValue();
 }

 

} /* end class Perspective */

