
package webflow.frontend;


import java.awt.*;
import java.util.Vector;
import java.io.*;
import uci.graphedit.*;
import webflow.backend.*;


/**
*/
public class 
WebPort extends NetPort
        implements UserInterfaceDebug
{

   /** */
   private String _type;
 
   /** */
   private ID myID;

   public 
   WebPort(NetNode parent, String type) 
   {
      super(parent);
      _type = new String( type );

      if (!(parent instanceof WebNode)) 
      {
        // throw an exception
        // System.out.println("WebPorts are only to be used on SampleNodes");

      }// end of if

   }// end of constructor

   public String 
   getType()
   { return _type; }

   /** 
   * Add the constraint that WebPort's can only be connected to
   * other ports of the same type. 
   */
   public boolean 
   canConnectTo(WebPort anotherPort) 
   {
     return ( super.canConnectTo((NetPort)anotherPort)) &&
              (anotherPort.getClass() == this.getClass());
   }// end of canConnectTo()

   /**
   */
   public void 
   setID( ID portID )
   { myID = portID; }

   /**
   */
   public ID 
   getID()
   { return myID;}

   /**
   */
   protected Class
   defaultArcClass(NetPort otherPort)
   {
      if( DEBUG == true )
          System.out.println(" I am in defaultArcClass of WebPort ");
      
      try
      { return Class.forName("webflow.frontend.WebArc");
      } catch( java.lang.ClassNotFoundException cnf)
        {  return super.defaultArcClass(otherPort);  }

   }// end of defaultArcClass()
  
}// end of class WebPort 


