
package webflow.frontend;

import java.awt.*;
import uci.graphedit.*;
import java.awt.event.*;



/**
* PaletteTop objects are derived from the Palet
* object and they can not control the WINDOW_DESTROY
* event. When you use this frame as this object's frame
* then this will take care of this event also and notify
* the editor about this WINDOW_DESTROY event. 
*
* When we switch to JDK 1.1, I don't think we are going to 
* need this. In that framework, we can define ActionListener
* objects so that I guess it will be easier and simpler.
*
*/
public 
class gefFrame extends Frame
               implements UserInterfaceDebug 
{
   /** 
   * Editor to whom we are going to send the
   * Event.WINDOW_DESTROY event.
   */
   private  Editor myEditor = null;

   /**
   * You have to provide the Editor object.
   */
   gefFrame(Editor _myEditor)
   { 
      
     myEditor = _myEditor; 
     setResizable(true);

   }

   /**
   * This only handles the Event.WINDOW_DESTROY event
   * end tells its editor object to execute ActionQuit.
   */
   public boolean
   handleEvent(Event e)
   {
     boolean ret = false;

     switch(e.id)
     {
       case Event.WINDOW_ICONIFY : break;

       case Event.WINDOW_DESTROY : 
            if(myEditor != null)
            {  
              if(DEBUG==true)
                System.out.println(" Event.WINDOW_DESTROY is being received !");

              /** Make sure Editor is WebEditor Object */ 
              if( myEditor instanceof WebEditor )
                  myEditor.executeAction(new ActionWebFlowQuit((WebEditor)myEditor),e);
              else 
                  myEditor.executeAction(new ActionQuit(),e);

              ret = true;
            }// end of if
            break;

     } // end of switch()

     return ret || super.handleEvent(e);

   }// end of handleEvent()

}// end of class gefFrame
