package webflow.modules.QuantumSimulations;

import webflow.backend.*;
import java.net.*;
import java.io.*;
import webflow.modules.Templates.*;

public class FTPout extends Template {
  
  /* PUT file
       to: remote file: outFile from input port
     from: local file : inFile to output port
     controls: FILE FDIR ATTR 
  */

  InputPort inport;
  OutputPort outport;
  String disp;
  String localfile, remotefile, rhost;
  WFFileDescriptor inFile;
  WFFileDescriptor outFile = new WFFileDescriptor();

  boolean flag=false;

  public MetaModule initialize() {
    
    CreateServerSocket();
    MetaModule mm = new MetaModule("mm");
    outport = new OutputPort("String");
    mm.putPortID(outport.getPortID());
    inport = new InputPort("String");
    mm.putPortID(inport.getPortID());
    return(mm);
    }
  
  public synchronized void run() {
    
    while(!flag) {
      // wait till rhost and outFile are specified
      try {
             wait(1000);
      } catch (InterruptedException e){;}
    }

    System.out.println("FTPout ready to go...");
    while(true) {

    inFile =(WFFileDescriptor)inport.receive();

    //defuault outFile

    outFile.setFileName(inFile.getFileName());
    outFile.setFileDirectory(inFile.getFileDirectory());
    outFile.setFileAttribute(inFile.getFileAttribute());
    //outFile.FileHost set by the frontend

    localfile = inFile.getFileDirectory()+inFile.getFileName();

    //default remotefile

    remotefile = outFile.getFileDirectory()+outFile.getFileName();
    rhost = outFile.getFileHost();


    //special treatemt of special files

    System.err.println("ATTRIBUTE: "+inFile.getFileAttribute());

    if(inFile.getFileAttribute().equals("GAUSSIAN")) {
       outFile.setFileDirectory("/scratch-modi4/haupt/GAUSSIAN/");
       remotefile = outFile.getFileDirectory()+outFile.getFileName();
    }
    if(inFile.getFileAttribute().equals("GAMESS")) {
       outFile.setFileDirectory("/scratch-modi4/haupt/GAMESS/");
       remotefile = outFile.getFileDirectory()+outFile.getFileName();
    }
    if(inFile.getFileAttribute().equals("CERIUS2")) {
       outFile.setFileDirectory("/scratch-modi4/haupt/CERIUS2/");
       remotefile = outFile.getFileDirectory()+outFile.getFileName();
    }
    if(inFile.getFileAttribute().equals("GAUS2PDB")) {
       outFile.setFileDirectory("/tmp/");     //osprey4
       remotefile = outFile.getFileDirectory()+"gaussian.out";
    }


        //generate ftpscript on the fly
        String ftpfile="/tmp/ftpScript";
        String ftpFileContents = new String("put "+localfile+" "+remotefile);
        int sl = ftpFileContents.length();
        byte[] ftpbuf = new byte[sl];
        ftpFileContents.getBytes(0,sl,ftpbuf,0);

        File to_file = new File(ftpfile);
        if(to_file.exists()) {
          if(!to_file.canWrite()) {
             System.out.println("FTP failed: file "+ftpfile+"is unwritable");
	  }
	}

        FileOutputStream to = null;
        try {
          to = new FileOutputStream(to_file);
          to.write(ftpbuf,0,sl);
        } catch (IOException e) {;}

        finally {
          if(to !=null) try {to.close();} catch (IOException e) {;}
        }
 

        //generate ftp0 file on the fly
        String ftp0file="/tmp/ftp0";
        String ftp0FileContents = "ftp "+rhost+ "< "+ftpfile;
        int sl0 = ftp0FileContents.length();
        byte[] ftp0buf = new byte[sl0];
        ftp0FileContents.getBytes(0,sl0,ftp0buf,0);

        File to_file0 = new File(ftp0file);
        if(to_file0.exists()) {
          if(!to_file0.canWrite()) {
             System.out.println("FTP failed: file "+ftp0file+"is unwritable");
	  }
	}

        FileOutputStream to0 = null;
        try {
          to0 = new FileOutputStream(to_file0);
          to0.write(ftp0buf,0,sl0);
        } catch (IOException e) {;}

        finally {
          if(to0 !=null) try {to0.close();} catch (IOException e) {;}
        }



        // give it executable permissions and run it

 
    try {
         System.out.println("change file permission");
         Process p1 = Runtime.getRuntime().exec("chmod 777 "+ftp0file);
         p1.waitFor();
    }
        catch (Exception e) {
        System.out.println("FTPin Error: " + e.toString());
    }




        //do ftp

 
	String ftpcmd = "/usr/bin/X11/xterm -d "+disp+":0 -e "+ftp0file;
        //String ftpcmd = ftp0file;

        try {
            Process p = Runtime.getRuntime().exec(ftpcmd);
            p.waitFor();
        }
            catch (Exception e) {
            System.out.println("Error: " + e.toString());
        }

      if(outport.isConnected()) {
        outport.send(outFile); 
        System.out.println("FTPout sent: "+outFile.getFileName());
      }
      else {
        System.out.println("FTPout: Output Port is not connected!");
      }
    }
  
  }
  
    
    public void destroy() {

    inport.destroyPort();
    outport.destroyPort();
    socket.stop();
    }
    
    public void stop() {}

   
    public void update_value(String s) {

    System.out.println("FTPout received: "+s);

         if(s.startsWith("DISP")) {
            disp=s.substring(4);
	 }
         if(s.startsWith("FDIR")) {
            outFile.setFileDirectory(s.substring(4));
	 }
         if(s.startsWith("ATTR")) {
            outFile.setFileAttribute(s.substring(4));
	 }
         if(s.startsWith("FILE")) {
            outFile.setFileName(s.substring(4));
	 }
         if(s.startsWith("HOST")) {
            outFile.setFileHost(s.substring(4));
            flag=true;
         }
    }
}	
    
    
    
