package webflow.modules.QuantumSimulations;


// $Id: FileBrowser.java,v 1.2 1998/04/19 06:48:52 haupt Exp haupt $

import java.util.*;
import java.lang.*;
import webflow.backend.*;
import java.net.*;
import java.io.*;
import webflow.modules.Templates.*;

public class FileBrowser extends Template {
  
  OutputPort outport;
  String newmessage;
  boolean flag,dirflag;
  WFFileDescriptor outFile = new WFFileDescriptor();
  int idx;

  public MetaModule initialize() {
    
    System.err.println("Initialize FileBrowser");
    CreateServerSocket();
    System.err.println("Socket done FileBrowser");
    MetaModule mm = new MetaModule("mm");
    outport = new OutputPort("WFFileDescriptor");
    mm.putPortID(outport.getPortID());
    System.err.println("about to end init FileBrowser");
    return(mm);
    }
  
  public synchronized void run() {
    
    newmessage="whatever";
    outFile.setFileAttribute("default");    
    outFile.setFileHost("local");    
    flag=false;
    dirflag=false;

    while(true) {
      try {
             wait(1000);
      } catch (InterruptedException e){;}
      
             if(newmessage.equals("ShutUp")) {break;}
	     if(flag) {
//   System.err.println("FileBrowser: create outFile with "+newmessage);
               idx=newmessage.lastIndexOf("/");
               outFile.setFileName(newmessage.substring(idx+1));
// System.err.println("FileBrowser: file name "+outFile.getFileName());
               outFile.setFileDirectory(newmessage.substring(0,idx+1));
// System.err.println("FileBrowser: directory "+outFile.getFileDirectory());
               if(outFile.getFileDirectory().lastIndexOf("GAUSSIAN")>0) {
                  outFile.setFileAttribute("GAUSSIAN");
	       }
               if(outFile.getFileDirectory().lastIndexOf("GAMESS")>0) {
                  outFile.setFileAttribute("GAMESS");
	       }
               if(outFile.getFileDirectory().lastIndexOf("CERIUS2")>0) {
                  outFile.setFileAttribute("CERIUS2");
	       }
               if(outFile.getFileDirectory().lastIndexOf("GAUS2PDB")>0) {
                  outFile.setFileAttribute("GAUS2PDB");
	       }
   System.err.println("FileBrowser: send outFile with "+outFile.getFileName());
               outport.send(outFile); 
               flag=false;
	       dirflag=false;
      	     }
    }

  }
  
    
    public void destroy() {

    outport.destroyPort();
    socket.stop();
    }
    
    public void stop() {}

   
    public void update_value(String s) 
    {
      
      String[] directory_contents=null;
      System.err.println("update_value is CALLED with "+s);
      
      if(s.equals("_make_connection")) {
       System.err.println("CONTROLS1 CONNECTED !!!");
      }
       else if (s.startsWith("SWING_REQ")){
	   System.err.println("I received DIR NAME:"+s);
	   
	   //received directory name for file browser
	   String dir = s.substring("SWING_REQ".length());
	   try{
	     directory_contents = list(dir,"");
	   }catch(InterruptedException e){
	   }
	   send_directory_contents(directory_contents);
	   dirflag = true;
	 }  
	 else if (s.startsWith("SWING_REPLY")){
	   newmessage=s.substring("SWING_REPLY".length()); 
	   System.err.println("new message arrived: "+newmessage);
	   flag=true;
	 }
      
    }
    
public void send_directory_contents(String []list)
  {
    
    socket.send(list[0]);
    int nfiles = list.length-1;
    socket.send(Integer.toString(nfiles));
    
    for(int i=1;i<list.length;i++){
//      System.err.println("sent FileBrowser ="+list[i]);
      socket.send(list[i]);
    }
  }
  

  public  String [] list(String dir,String opts)
         throws InterruptedException
  {
    boolean isExist=false,isRead=false;
    Vector lines = new Vector();

    System.err.println(dir+" is requested "); 
    //insert first requested directory name
    lines.addElement(dir);

    //check that this directory exists first
    File file = new File(dir);
    try{
      if (file.exists())
	isExist = true;
      isRead = true;
    }catch(SecurityException e){
      System.err.println("Security Exception "+e);
    }
    
    if (!isRead){
      System.err.println(dir+" is not readable");
      lines.addElement("total xx");   
      lines.addElement("NotReadable");
    }
    else if (!isExist){
      System.err.println(dir+" Not Found");
      lines.addElement("total xx");
      lines.addElement("NotFound");
    }
    if ((!isRead)||(!isExist)){
      System.err.println("file "+dir+" not found or not readable");
      String[] retval = new String[lines.size()];
      lines.copyInto(retval);
      return retval;
    }

    try{
      
      String line;
      String  cmd,pwd=null;
      Process child;
      DataInputStream in;

      //start up the command
      cmd = "ls -al "+dir;
      child = Runtime.getRuntime().exec(cmd);
      in = new DataInputStream(child.getInputStream());
      
      //read the command's output
      while((line = in.readLine()) != null)
	lines.addElement(line);

      String[] retval = new String[lines.size()];
      lines.copyInto(retval);
      return retval;
    } catch (Exception e){
      throw new InterruptedException (e.toString());
    }
  }


}	
    
    
    


