package webflow.modules.QuantumSimulations;

import webflow.backend.*;
import java.net.*;
import java.io.*;
import webflow.modules.Templates.*;

public class GRAM extends Template {
  
  InputPort inport;
  OutputPort outport;
  String message,newmessage;
  String command;
  String disp, dummy;
  String gatekeeper, executable, arguments;  
  String stdin; 
  String contact;

  public MetaModule initialize() {
    
    CreateServerSocket();
    MetaModule mm = new MetaModule("mm");
    inport = new InputPort("String");
    mm.putPortID(inport.getPortID());
    outport = new OutputPort("String");
    mm.putPortID(outport.getPortID());
    newmessage=null;
    disp="dummy";
    gatekeeper=null;
    return(mm);
    }
  
  public void run() {
    
    //wait till you know the ip address of the display
    
    while(newmessage==null) {;}
    System.out.println("set display to: "+newmessage);
    disp=newmessage;

    //wait till you know gatekeeper
    // accept default executable and arguments
    
    while(gatekeeper==null) {
      try {wait(1000);}
      catch (Exception e) {;}
    }

     executable="grami_test_app";
     arguments="aaa bbb ccc ddd";

    while(true)
      {
        stdin = (String)inport.receive();

    //input data

     String gramfile="/tmp/gramScript";
   //gatekeeper="osprey2.npac.syr.edu";
     String directory="/home/B7D/globus/haupt";
   //String stdin="/home/B7D/globus/globus/BUILD/becrux/gram/test/tom_stdin";
   //String stdout="/home/B7D/globus/globus/BUILD/becrux/gram/test/tom_stdout";
   //String stderr="/home/B7D/globus/globus/BUILD/becrux/gram/test/tom_stderr";
   //String stdin="/tmp/gram_stdin";
     String stdout="/tmp/gram_stdout";
     String stderr="/tmp/gram_stderr";

     // make sure that the client code exists!

     String clientcodename="gram_client_test";
     String clientcode="/tmp/"+clientcodename;
     String defaultdir="/home/B7D/globus/haupt/"; 
     File client=new File(clientcode);
     if(!client.exists()) {
         System.out.println("GRAM-client code does not exist");
         String copycmd="cp "+defaultdir+clientcodename+" "+clientcode;
         try {
               Process p0 = Runtime.getRuntime().exec(copycmd);
               p0.waitFor();
	 } catch (Exception e) {
             System.out.println("Error: " + e.toString());
         }
     System.out.println("file copied"); 
     }
        //generate script on the fly

        String FileContents = new String("#!/bin/sh -f\n");
        FileContents += "gatekeeper_contact="+contact+"\n";
        FileContents += "spec=\"&(directory="+directory+")(executable="+executable+")(arguments="+arguments+")(stdin="+stdin+")(stdout="+stdout+")(stderr="+stderr+")(count=1)\"\n";
        FileContents += "job_state_mask=3\n";
        FileContents += clientcode+" $gatekeeper_contact \"$spec\" $job_state_mask\n";

	// write it to a file

        int sl = FileContents.length();
        byte[] ftpbuf = new byte[sl];
        FileContents.getBytes(0,sl,ftpbuf,0);

        File to_file = new File(gramfile);
        if(to_file.exists()) {
          if(!to_file.canWrite())
             System.out.println("write failed: file "+gramfile+" is unwritable");
        }


        FileOutputStream to = null;
        try {
          to = new FileOutputStream(to_file);
          to.write(ftpbuf,0,sl);
        } catch (IOException e) {;}

        finally {
          if(to !=null) try {to.close();} catch (IOException e) {;}
        }

        // give it executable permissions and run it

 
    try {
         System.out.println("change file permission");
         Process p1 = Runtime.getRuntime().exec("chmod 777 "+gramfile);
         p1.waitFor();
         System.out.println("execute the script");
         Process p = Runtime.getRuntime().exec("xterm -d "+disp+":0 -e "+gramfile);
         p.waitFor();
    }
        catch (Exception e) {
        System.out.println("Error: " + e.toString());
    }


        System.out.println("GRAM: forwarding "+stdout);
       	outport.send(stdout);
      }
  }
  
    
    public void destroy() {

    outport.destroyPort();
    inport.destroyPort();
    }
    
    public void stop() {}
    
    public void update_value(String s) {
    System.out.println("GRAM: new message: "+s);
    newmessage = s;
    dummy = disp;
    disp = s;
    if(newmessage.startsWith("GATE")) {
      gatekeeper = newmessage.substring(4);
      if(gatekeeper.equals("NPAC osprey2")) {
       contact="osprey2.npac.syr.edu:754:osprey2.npac.syr.edu-fork@globus.org";
      }
      if(gatekeeper.equals("NPAC osprey4")) {
       contact="osprey4.npac.syr.edu:754:osprey2.npac.syr.edu-fork@globus.org";
      }
      if(gatekeeper.equals("NCSA Origin2000 (f)")) {
        contact="modi4.ncsa.uiuc.edu:4001:modi4.ncsa.uiuc.edu-fork@globus.org";
      }
      if(gatekeeper.equals("NCSA Origin2000 (lsf)")) {
        contact="modi4.ncsa.uiuc.edu:4000:modi4.ncsa.uiuc.edu-lsf@globus.org";
      }
      disp=dummy;
    }  
    if(newmessage.startsWith("EXEC")) {
      executable = newmessage.substring(4);
      disp=dummy;
    }  
    if(newmessage.startsWith("ARGS")) {
      arguments = newmessage.substring(4);
      disp=dummy;
    }  


  }   

}	
    
    
    
