package webflow.modules.QuantumSimulations;

import webflow.backend.*;
import java.net.*;
import java.io.*;
import webflow.modules.Templates.*;

public class GetFile extends Template {

  /* GET file
     from: remote file: inFile from input port
       to: local file : outFile to output port
           default directory: /tmp/
           default filename: WFtemp.txt
     controls: FILE FDIR ATTR 
  */

  InputPort inport;
  OutputPort outport;
  String disp;
  WFFileDescriptor inFile;
  WFFileDescriptor  outFile = new WFFileDescriptor("WFtemp.txt");
  String IFileName, rhost, IDir, IAttr;  //inFile attributes
  String localfile;
  boolean flag=false;

  public MetaModule initialize() {
    
    System.err.println("Initialize GetFile");
    CreateServerSocket();
    MetaModule mm = new MetaModule("mm");
    outport = new OutputPort("String");
    mm.putPortID(outport.getPortID());
    inport = new InputPort("String");
    mm.putPortID(inport.getPortID());
    return(mm);
    }
  
  public synchronized void run() {
    
    /*
    //flag=false;
        while(!flag) {
      // wait till rhost is specified
      try {
             wait(1000);
      } catch (InterruptedException e){;}
    }
    */

    // I put default action: always send to /tmp/inFile.getFileName()
    // and preserve fileAttribute; fileHost set to "local"

    // GAUS2PDB special action: "/tmp/gaussian.pdb -> /tmp/inFile.getFileName()
    // this is marked by attribute CERIUS2


    System.err.println("GetFile ready to go");
    //set defaults

    while(true) {
      inFile = (WFFileDescriptor)inport.receive();

      
      if(inFile.getFileAttribute().equals("CERIUS2")) {
        IFileName = "/tmp/gaussian.pdb";
      }
      else {
         IFileName = inFile.getFileDirectory()+inFile.getFileName();
      }
      rhost = inFile.getFileHost();
      System.err.println("inFile host :"+rhost); 
      System.err.println("inFile attr :"+inFile.getFileAttribute());
      outFile.setFileAttribute(inFile.getFileAttribute());
      outFile.setFileName(inFile.getFileName());
      outFile.setFileDirectory("/tmp/");
      outFile.setFileHost("local");
          
        //generate ftpscript on the fly
        String ftpfile="/tmp/ftpScript";
        localfile = outFile.getFileDirectory()+outFile.getFileName();
        String ftpFileContents = new String("get "+IFileName+" "+localfile);
        int sl = ftpFileContents.length();
        byte[] ftpbuf = new byte[sl];
        ftpFileContents.getBytes(0,sl,ftpbuf,0);

        File to_file = new File(ftpfile);
        if(to_file.exists()) {
          if(!to_file.canWrite()) {
             System.err.println("FTP failed: file "+ftpfile+"is unwritable");
	  }
	}

        FileOutputStream to = null;
        try {
          to = new FileOutputStream(to_file);
          to.write(ftpbuf,0,sl);
        } catch (IOException e) {;}

        finally {
          if(to !=null) try {to.close();} catch (IOException e) {;}
        }
 

        //generate ftp0 file on the fly
        String ftp0file="/tmp/ftp0";
        String ftp0FileContents = "ftp "+rhost+ "< "+ftpfile;
        int sl0 = ftp0FileContents.length();
        byte[] ftp0buf = new byte[sl0];
        ftp0FileContents.getBytes(0,sl0,ftp0buf,0);

        File to_file0 = new File(ftp0file);
        if(to_file0.exists()) {
          if(!to_file0.canWrite()) {
             System.err.println("FTP failed: file "+ftp0file+"is unwritable");
	  }
	}

        FileOutputStream to0 = null;
        try {
          to0 = new FileOutputStream(to_file0);
          to0.write(ftp0buf,0,sl0);
        } catch (IOException e) {;}

        finally {
          if(to0 !=null) try {to0.close();} catch (IOException e) {;}
        }


        // give it executable permissions and run it

 
    try {
         System.err.println("change file permission");
         Process p1 = Runtime.getRuntime().exec("chmod 777 "+ftp0file);
         p1.waitFor();
    }
        catch (Exception e) {
        System.err.println("GetFile Error: " + e.toString());
    }


        //do ftp

 
	String ftpcmd = "/usr/bin/X11/xterm -d "+disp+":0 -e "+ftp0file;
        //String ftpcmd = ftp0file;

        try {
            Process p = Runtime.getRuntime().exec(ftpcmd);
            p.waitFor();
        }
            catch (Exception e) {
            System.err.println("Error: " + e.toString());
        }

      if(outport.isConnected()) {
       outport.send(outFile); 
       System.err.println("GetFile sent: "+localfile);
       System.err.println("outFile attr :"+outFile.getFileAttribute());
      }
      else {
        System.err.println("GetFile Output Port is not connected!");
      }
       flag=false;
    }
    

   
  }
  
    
    public void destroy() {

    outport.destroyPort();
    inport.destroyPort();
    socket.stop();
    }
    
    public void stop() {}

   
    public void update_value(String s) {

         System.err.println("GetFile received: "+s);

         if(s.startsWith("DISP")) {
            disp=s.substring(4);
	 }
         if(s.startsWith("FDIR")) {
            outFile.setFileDirectory(s.substring(4));
	 }
         if(s.startsWith("ATTR")) {
            outFile.setFileAttribute(s.substring(4));
	 }
         if(s.startsWith("FILE")) {
            outFile.setFileName(s.substring(4));
            flag=true;
	 }
    }
}	
    
    
    
