package webflow.modules.demo.SciVis;

// Import For webFlow Components
import webflow.backend.Module;
import webflow.backend.MetaModule;

// Standard JAVA Classes
import java.awt.*;
import java.net.*;
import java.io.*;

/**
* Reads 2D array and produce java_ser parameters for the SciVis.
*/
public class 
SciVis1D_ser  implements Module
{
	
    SciVisPort1D_ser sciVisDataPort ; 
    SciVisInfoReader infoReader = null;

    ServerSocket listener;
    Socket aSocket;
    String hostName;
    int portNumber;

    String SciVisHost = null;
    int SciVisPort = -1;

    String winName = null;
	
    public MetaModule 
    initialize()
    {

      MetaModule mm  = new MetaModule("SciVis1D_ser");

      System.out.println("I am in SciVis1D_ser Module");
 
      sciVisDataPort = new SciVisPort1D_ser();

      mm.putPortID(sciVisDataPort.getPortID());

      try
      {
            InetAddress local = java.net.InetAddress.getLocalHost();
            hostName = local.getHostName();
            listener = new ServerSocket(0);
            portNumber = listener.getLocalPort();
  
      } catch( UnknownHostException uhe) 
        { System.out.println("SciVis_ser:"+uhe); }
        catch( IOException ioe) 
        { System.out.println("SciVis_ser:"+ioe); }

      try
      {
         BufferedReader bR = new BufferedReader( new InputStreamReader(new FileInputStream("SciVis.config")));
             
         String line1 = bR.readLine();
         String line2 = bR.readLine();

         if(line1!=null && line2!=null)
         {
            SciVisHost = line1.trim();

            try
            {
               SciVisPort = Integer.parseInt(line2.trim());

               sciVisDataPort.setSciVisHostName(SciVisHost);

               sciVisDataPort.setSciVisPort(SciVisPort);


            } catch(NumberFormatException nfe)
              { defineInterface(mm); }
                
         }  else defineInterface(mm); 
              
      } catch(IOException ioe)
        {
               defineInterface(mm); 
        }

      //winName = new String(mm.getModuleID().getString());
      winName = new String("Voyayer");
      
      return(mm);
		
    }// end of initialize()


    void
    defineInterface(MetaModule mm)
    {
        System.out.println("File does not exist");

        infoReader = new SciVisInfoReader(listener,sciVisDataPort);

        String htmlString = new String("CODE =\"webflow.modules.demo.SciVis.SciVisApplet.class\" width=200 height=200>\n");
        htmlString = htmlString + "<PARAM name=Host VALUE=" + hostName +" > ";
        htmlString = htmlString + "<PARAM name=portnum VALUE=" + String.valueOf(portNumber) +" > ";
        
        htmlString = htmlString + "<PARAM name=FName Value=SciVisInput>\n</APPLET></p>\n";
        System.out.println(htmlString);
        
        mm.setHTML(htmlString);

    }// end of defineInterface()

    /**
    */
    public void 
    run()
    {

       boolean stay = true;
       sciVisDataPort.setWinName(winName);
       float timeCounter = 0f;
 
       /** Read Where the SciVis is */

       while(stay)
       {
           Object data = sciVisDataPort.receive();

           sciVisDataPort.setWinName(winName);
           sciVisDataPort.setTime(timeCounter);

           if(data!=null) 
           { 
               System.out.println(" I will send data for "+timeCounter+" to the SciVis "+winName);        
               sciVisDataPort.send(data);
               timeCounter++;

           }// end of if

           //else stay = false; 
 
       }// end of while

       System.out.println(" I am out of ru() in SciVis1D_ser.java ");        
		
    }// end of run()

    /**
    */
    public void 
    destroy()
    {
		sciVisDataPort.closeSocket();
		sciVisDataPort.destroyPort();
        if(infoReader!=null) infoReader.stop();

    }// end of destroy()
	
    /**
    */
	public void 
    stop(){}

    /**
    * TestStub
    */
	public static void 
    main(String[] args)
    {

       SciVis1D_ser emb = new SciVis1D_ser();
       emb.initialize();
       emb.destroy();

    }// end of TestStub		

}// end of class SciVis2D_ser 	
	

