package webflow.modules.demo.SciVis;

import java.io.DataInputStream;
import java.io.ByteArrayInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

/**
* For java_bbser2d
*/
public class 
SciVisData2D_bbser implements SciVisData 
{

  int command = 25;
  String name = null;
  double time ;
  
  double[] fxy;
  int nx = 0;
  int ny = 0;

  double[] bb = new double[4];

  /**
  */
  public
  SciVisData2D_bbser() {};

  /**
  */
  public
  SciVisData2D_bbser(String _name, double _time, 
                       int _nx, int _ny, double[] _bb, double[] _fxy) 
  {

      name = new String(_name);
      time = _time;
      fxy  = new double[_nx*_ny];
      nx   = _nx;
      ny   = _ny;
     
      for(int i=0;i<nx*ny;i++) fxy[i] = _fxy[i];

      bb[0] = _bb[0];
      bb[1] = _bb[1];
      bb[2] = _bb[2];
      bb[3] = _bb[3];

  }

  /**
  */
  public void
  setWinName(String _name)
  { 
     name = new String(_name);
  }

  /**
  */
  public void
  setTime(float _time)
  {
     time = (double)_time;
  }

  /**
  * 
  * read bounding box
  * read number of x
  * read number of y
  * read fxy ( size is nx * ny )
  */
  public int 
  readFrom(DataInputStream inData) throws IOException
  {
     int retVal = 0;

     int num_ele = inData.readInt();

     System.out.println(" I will read  num_ele elements = "+num_ele);

     byte[] data = new byte[num_ele]; 

     inData.readFully(data,0,num_ele);

     System.out.println(" I will read  rest elements = "+num_ele);

     DataInputStream in = new DataInputStream(new ByteArrayInputStream(data));

     /** Read the bounding box */
     bb[0] = in.readFloat();
     bb[1] = in.readFloat();
     bb[2] = in.readFloat();
     bb[3] = in.readFloat();

     /** Read the number of elements */
     nx = in.readInt();
     ny = in.readInt();

     System.out.println(" I will read  nx elements = "+nx+" and ny = "+ny);

     /** Define the elements */
     fxy = new double[nx*ny];

     /** Read the elements */
     for(int i=0;i<nx*ny;i++) fxy[i] = in.readDouble();

     retVal = 1;
     System.out.println(" I read all data !!!!! ");

     return retVal;

  }// end of readFrom()

  /**
  */
  public int 
  writeTo(DataOutputStream out) throws IOException
  {
     int retVal = 0;

     /** Write Command */
     out.writeInt(command);

     if(name==null) name = new String("Standard#10");

     /** Write length of The Name of the Window */
     out.writeInt(name.length());

     /** Write The Name of the Window */
     out.writeBytes(name);

     System.out.println(" Window name is "+name);

     /** Write Time */
     out.writeFloat((float)time);

     /** Write Number of elements in X-Axis */
     out.writeInt(nx);

     /** Write Number of elements in Y-Axis */
     out.writeInt(ny);

     /** Write bounding box */
     out.writeFloat((float)bb[0]);
     out.writeFloat((float)bb[1]);
     out.writeFloat((float)bb[2]);
     out.writeFloat((float)bb[3]);

     /** Write elements */
     for(int i=0;i<nx*ny;i++) out.writeFloat((float)fxy[i]);

     retVal = 1;

     return retVal;

  }// end of writeTo()

}// end of SciVisData2D_bbser2d

