package webflow.modules.demo.SciVis;

import java.io.DataInputStream;
import java.io.ByteArrayInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

/**
* For java_ser2d
* Updates <br>
* <ol>
*  <li> (Nov.11.1997) readFrom reads the window name.
* </ol>
* @date October 13, 1997
*/
public class 
SciVisData2D_ser2d implements SciVisData 
{

  int command = 15;
  String name = null;
  double time ;
  double[] x;
  double[] y;
  double[] fxy;
  int nx = 0;

  boolean windowSettingAllowed = true;

  /**
  */
  public
  SciVisData2D_ser2d() {};

  /**
  */
  public
  SciVisData2D_ser2d(String _name, double _time, int _nx, 
               double[] _x, double[] _y, double[] _fxy) 
  {

      if(_name!=null) name = new String(_name);
      time = _time;
      nx   = Math.min(Math.min(Math.min(_x.length,_y.length),_fxy.length),_nx);
     
      if(nx>0)
      {
          x = new double[nx];
          y = new double[nx];
         fxy = new double[nx];

         for(int i=0;i<nx;i++)
         {
             x[i] = _x[i];
             y[i] = _y[i];
            fxy[i] = _fxy[i];

         }// end of for

      }// end of if

      if(name!=null) windowSettingAllowed = false;
  }

  /**
  */
  public void
  setWinName(String _name)
  { 
     if(windowSettingAllowed && _name!=null) name = new String(_name);
  }

  /**
  */
  public void
  setTime(float _time)
  {
     if(time>=0) time = (double)_time;
  }

  /**
  * 
  */
  public int 
  readFrom(DataInputStream inData) throws IOException
  {
     int retVal = 0;

     int num_ele = inData.readInt();

     System.out.println(" I will read  num_ele elements = "+num_ele);

     byte[] data = new byte[num_ele]; 

     inData.readFully(data,0,num_ele);

     System.out.println(" I will read  rest elements = "+num_ele);

     DataInputStream in = new DataInputStream(new ByteArrayInputStream(data));

     /** Read the number of characters in Window Name */
     int size = in.readInt();

     windowSettingAllowed = !(size>0);

     if(size>0)
     {
         byte[] nData = new byte[size];
         in.readFully(nData,0,size);
         name = new String(nData);
     }
  
     /** Read the number of elements */
     nx = in.readInt();
     System.out.println(" I will read  nx elements = "+nx);

     /** Define the elements */
     x = new double[nx];
     y = new double[nx];
     fxy = new double[nx];

     /** Read the elements */
     for(int i=0;i<nx;i++)
     {
         x[i] = in.readDouble();
         y[i] = in.readDouble();
        fxy[i] = in.readDouble();
        //System.out.print(" ( "+x[i]+" , "+fx[i]+" ) ");

     }// end of for

     retVal = 1;
     System.out.println(" I read all data !!!!! ");

     return retVal;

  }// end of readFrom()

  /**
  */
  public int 
  writeTo(DataOutputStream out) throws IOException
  {
     int retVal = 0;

     /** Write Command */
     out.writeInt(command);

     if(name==null) name = new String("Standard#10");

     /** Write length of The Name of the Window */
     out.writeInt(name.length());

     /** Write The Name of the Window */
     out.writeBytes(name);

     System.out.println(" Window name is "+name);

     /** Write Time */
     out.writeFloat((float)time);

     /** Write Number of elements */
     out.writeInt(nx);

     /** Write elements */
     for(int i=0;i<nx;i++)
     {
        out.writeFloat((float)x[i]);
        out.writeFloat((float)y[i]);
        out.writeFloat((float)fxy[i]);

     }// end of for

     retVal = 1;

     return retVal;

  }// end of writeTo()

}// end of SciVisData2D_ser2d

