package webflow.modules.demo.SciVis;

import java.lang.*;
import java.io.*;
import webflow.backend.*;

public class SciVisDataObj
{
public static final int    T_INT         =  551 ;
public static final int    T_FLOAT       =  552;
public static final int    T_DOUBLE      =  553;
public static final int    T_CHAR        =  554;
public static final int    T_BOOL        =  555;
public static final int    T_STRING      =  556;
public static final int    T_ENUM        =  557;
public static final int    T_SUBRANGE    =  558;
public static final int    T_LIST        =  559;
public static final int    T_ARRAY       =  560;
public static final int    T_RECORD      =  561;
public static final int    T_LONG        =  587;
public static final int    T_SHORT       =  588;
public static final int    T_BYTE        =  589;

  
  public Object buffer;
 public  int tag;
 public  String varName ;
  public int type;
  public int ndims;
  public   int nelems;
 public recv_module rlib;
public int dims[];
public double[] xval;
public double[] db1;
public double[][]db; 
public double[][]fxyz;
  public SciVisDataObj(recv_module rlib){
    this.rlib = rlib;
  }
       
   public void read(){
    buffer=null;

    // receive tag
    float fval ;
    try{        
     tag = rlib.recv_int();
    System.out.println("tag = " + tag);
    varName=rlib.recv_String().toString();
    System.out.println("varName = " + varName);
     type  = rlib.recv_int();
   System.out.println("type = " + type);	
    ndims = rlib.recv_int();
   System.out.println("ndims = " + ndims);
     nelems = rlib.recv_int();
System.out.println("nelems = " + nelems);
    if (ndims > 0){
	System.out.println("DIM " + ndims);
      dims = new int[ndims];
      rlib.recv_1Dint_array(dims);
    }
    System.out.println("RECEIVED  "+tag+" "+varName+" "+type+" "+ndims+" "+
               nelems+" ");
    switch(type){
    case T_INT:
      switch(ndims){
        case 0:
          int num = rlib.recv_int();
          buffer = new Integer(num);
          break;
        case 1:
          buffer = new int[dims[0]];
          rlib.recv_1Dint_array((int[])buffer);
          break;
        case 2:  
          buffer = new int[dims[0]][dims[1]];
          rlib.recv_2Dint_array((int[][])buffer);
          break;
        case 3:
          buffer = new int[dims[0]][dims[1]][dims[2]];
          rlib.recv_3Dint_array((int[][][])buffer);
          break;
      }
      break;
      case T_CHAR:
      switch(ndims){
        case 0:
          char num = rlib.recv_char();
          buffer = new Character(num);
          break;
        case 1:
          buffer = new char[dims[0]];
          rlib.recv_1Dchar_array((char[])buffer);
          break;
        case 2:  
          buffer = new char[dims[0]][dims[1]];
          rlib.recv_2Dchar_array((char[][])buffer);
          break;
        case 3:
          buffer = new char[dims[0]][dims[1]][dims[2]];
          rlib.recv_3Dchar_array((char[][][])buffer);
          break;
      }
      break;
      case T_FLOAT:
      switch(ndims){
        case 0:
          float num = rlib.recv_float();
          buffer = new Float(num);
          break;
        case 1:
          buffer = new float[dims[0]];
          rlib.recv_1Dfloat_array((float[])buffer);
          break;
        case 2:  
          buffer = new float[dims[0]][dims[1]];
          rlib.recv_2Dfloat_array((float[][])buffer);
          break;
        case 3:
          buffer = new float[dims[0]][dims[1]][dims[2]];
          rlib.recv_3Dfloat_array((float[][][])buffer);
          break;
      }
      break;
      case T_LONG:
      switch(ndims){
        case 0:
          long num = rlib.recv_long();
          buffer = new Long(num);
          break;
        case 1:
          buffer = new long[dims[0]];
          rlib.recv_1Dlong_array((long[])buffer);
          break;
        case 2:  
          buffer = new long[dims[0]][dims[1]];
          rlib.recv_2Dlong_array((long[][])buffer);
          break;
        case 3:
          buffer = new long[dims[0]][dims[1]][dims[2]];
          rlib.recv_3Dlong_array((long[][][])buffer);
          break;
      }
      break;
      case T_DOUBLE:
      switch(ndims){
        case 0:
          double num = rlib.recv_double();
          buffer = new Double(num);
          break;
        case 1:
          buffer = new double[dims[0]];
          rlib.recv_1Ddouble_array((double[])buffer);
         System.out.println("GOING FOR 1D array");
          db1 = new double[dims[0]];
	  db1=((double[])buffer);
	  xval= new double[dims[0]];
	  for(int m=0;m<dims[0];m++)
	    xval[m]=m;
          break;
        case 2:  
          buffer = new double[dims[0]][dims[1]];
          rlib.recv_2Ddouble_array((double[][])buffer);
 db = new double[dims[0]*dims[1]][3];
    int z=0;
    for(int k=0;k<dims[0];k++)
      for(int l=0;l<dims[1];l++){
        db[z][0]=k;
        db[z][1]=l;
       	db[z][2]=((double[][])buffer)[k][l];
        z++;
      }
	  System.out.println("ARRAY VALUES ARE  = "+ ((double[][])buffer)[1][1]);
	  for(int l=0;l<200;l++);
          break;
        case 3:
          buffer = new double[dims[0]][dims[1]][dims[2]];
          rlib.recv_3Ddouble_array((double[][][])buffer);
          fxyz= new double[dims[0]*dims[1]*dims[2]][4];

              for(int i=0;i<dims[0];i++)
    {
     for(int j=0;j<dims[1];j++)
     {
      for(int k=0;k<dims[2];k++)
      {
	 fxyz[(((i*dims[0])+j)*dims[1])+k][0]=1f*i;
	fxyz[(((i*dims[0])+j)*dims[1])+k][1]=1f*j;
	fxyz[(((i*dims[0])+j)*dims[1])+k][2]=1f*k;
       fxyz[(((i*dims[0])+j)*dims[1])+k][3]=((double[][][])buffer)[i][j][k];

}
       }
      }
          break;
      }
      break;
      case T_BOOL:
      switch(ndims){
        case 0:
          boolean num = rlib.recv_boolean();
          buffer = new Boolean(num);
          break;
        case 1:
          buffer = new boolean[dims[0]];
          rlib.recv_1Dboolean_array((boolean[])buffer);
          break;
        case 2:  
          buffer = new boolean[dims[0]][dims[1]];
          rlib.recv_2Dboolean_array((boolean[][])buffer);
          break;
        case 3:
          buffer = new boolean[dims[0]][dims[1]][dims[2]];
          rlib.recv_3Dboolean_array((boolean[][][])buffer);
          break;
      }
      break;
      case T_BYTE:
      switch(ndims){
        case 0:
          byte num = rlib.recv_byte();
          buffer = new Byte(num);
          break;
        case 1:
          buffer = new byte[dims[0]];
          rlib.recv_1Dbyte_array((byte[])buffer);
          break;
        case 2:  
          buffer = new byte[dims[0]][dims[1]];
          rlib.recv_2Dbyte_array((byte[][])buffer);
          break;
        case 3:
          buffer = new byte[dims[0]][dims[1]][dims[2]];
          rlib.recv_3Dbyte_array((byte[][][])buffer);
          break;
      }
      break;
      case T_SHORT:
      switch(ndims){
        case 0:
          short num = rlib.recv_short();
          buffer = new Short(num);
          break;
        case 1:
          buffer = new short[dims[0]];
          rlib.recv_1Dshort_array((short[])buffer);
          break;
        case 2:  
          buffer = new short[dims[0]][dims[1]];
          rlib.recv_2Dshort_array((short[][])buffer);
          break;
        case 3:
          buffer = new short[dims[0]][dims[1]][dims[2]];
          rlib.recv_3Dshort_array((short[][][])buffer);
          break;
      }
      break;
    }
   
    }catch(IOException e)
      {
	System.out.println("IOException in SciVisDataObj " +e);
      }
   } 


  /*public void write(BufferedOutputStream bos,DataInputStream dis)
  {
    try{
    DataOutputStream dos = new  DataOutputStream(bos);
    System.out.println("WRITING DATA " );
    dos.writeInt((8*dims[0]*dims[1])+(4*6));
    for (int l =0 ;l<1000;l++)
       System.out.println("Send data ="+(8*dims[0]*dims[1])+(4*6) );
    dos.writeInt(dims[0]);//nx
    dos.writeInt(dims[1]);//ny
    dos.writeInt(1);//bb[0]
    dos.writeInt(dims[0]);//bb[1]
    dos.writeInt(1);//bb[2]
    dos.writeInt(dims[1]);//bb[3] 
    //dos.writeInt(100);
// System.out.println("LEN = " + dims[0]*dims[1]);
    // for (int l=0;l<100;l++);
    int k=0;
    for(int i=0;i<dims[0];i++)
      for(int j=0;j<dims[1];j++)
	{
      	  dos.writeDouble(((double[][])buffer)[i][j]);
	  System.out.println("i = " +i +" j =" +j +" "+ ((double[][])buffer)[i][j]);
	}
        bos.flush();
    System.out.println("Sent data to the stream");
	System.out.println("Read Confirm = " + dis.readInt());
    dos.close();
    }catch(IOException e)
      {
	System.out.println("IOException in SciVisDataObj " +e);
      }
    
  }*/

  /*  public void  write(DataOutputStream dos)
    {
      send_module send_mod;
         float fval ;
        send_mod= new send_module(dos,false);
     send_mod.send_int(tag);
     send_mod.send_String(varName);
    send_mod.send_int(type);
    send_mod.send_int(ndims);
    send_mod.send_int(nelems);
    send_mod.send_1Dint_array(dims);
    switch(type){
    case T_INT:
      switch(ndims){
        case 0:
          int num = send_mod.send_int();
          buffer = new Integer(num);
          break;
        case 1:
          buffer = new int[dims[0]];
          send_mod.send_1Dint_array((int[])buffer);
          break;
        case 2:  
          buffer = new int[dims[0]][dims[1]];
          send_mod.send_2Dint_array((int[][])buffer);
          break;
        case 3:
          buffer = new int[dims[0]][dims[1]][dims[2]];
          send_mod.send_3Dint_array((int[][][])buffer);
          break;
      }
      break;
      case T_CHAR:
      switch(ndims){
        case 0:
          char num = send_mod.send_char();
          buffer = new Character(num);
          break;
        case 1:
          buffer = new char[dims[0]];
          send_mod.send_1Dchar_array((char[])buffer);
          break;
        case 2:  
          buffer = new char[dims[0]][dims[1]];
          send_mod.send_2Dchar_array((char[][])buffer);
          break;
        case 3:
          buffer = new char[dims[0]][dims[1]][dims[2]];
          send_mod.send_3Dchar_array((char[][][])buffer);
          break;
      }
      break;
      case T_FLOAT:
      switch(ndims){
        case 0:
          float num = send_mod.send_float();
          buffer = new Float(num);
          break;
        case 1:
          buffer = new float[dims[0]];
          send_mod.send_1Dfloat_array((float[])buffer);
          break;
        case 2:  
          buffer = new float[dims[0]][dims[1]];
          send_mod.send_2Dfloat_array((float[][])buffer);
          break;
        case 3:
          buffer = new float[dims[0]][dims[1]][dims[2]];
          send_mod.send_3Dfloat_array((float[][][])buffer);
          break;
      }
      break;
      case T_LONG:
      switch(ndims){
        case 0:
          long num = send_mod.send_long();
          buffer = new Long(num);
          break;
        case 1:
          buffer = new long[dims[0]];
          send_mod.send_1Dlong_array((long[])buffer);
          break;
        case 2:  
          buffer = new long[dims[0]][dims[1]];
          send_mod.send_2Dlong_array((long[][])buffer);
          break;
        case 3:
          buffer = new long[dims[0]][dims[1]][dims[2]];
          send_mod.send_3Dlong_array((long[][][])buffer);
          break;
      }
      break;
      case T_DOUBLE:
      switch(ndims){
        case 0:
          double num = send_mod.send_double();
          buffer = new Double(num);
          break;
        case 1:
          buffer = new double[dims[0]];
          send_mod.send_1Ddouble_array((double[])buffer);
          break;
        case 2:  
          buffer = new double[dims[0]][dims[1]];
          send_mod.send_2Ddouble_array((double[][])buffer);
          break;
        case 3:
          buffer = new double[dims[0]][dims[1]][dims[2]];
          send_mod.send_3Ddouble_array((double[][][])buffer);
          break;
      }
      break;
      case T_BOOL:
      switch(ndims){
        case 0:
          boolean num = send_mod.send_boolean();
          buffer = new Boolean(num);
          break;
        case 1:
          buffer = new boolean[dims[0]];
          send_mod.send_1Dboolean_array((boolean[])buffer);
          break;
        case 2:  
          buffer = new boolean[dims[0]][dims[1]];
          send_mod.send_2Dboolean_array((boolean[][])buffer);
          break;
        case 3:
          buffer = new boolean[dims[0]][dims[1]][dims[2]];
          send_mod.send_3Dboolean_array((boolean[][][])buffer);
          break;
      }
      break;
      case T_BYTE:
      switch(ndims){
        case 0:
          byte num = send_mod.send_byte();
          buffer = new Byte(num);
          break;
        case 1:
          buffer = new byte[dims[0]];
          send_mod.send_1Dbyte_array((byte[])buffer);
          break;
        case 2:  
          buffer = new byte[dims[0]][dims[1]];
          send_mod.send_2Dbyte_array((byte[][])buffer);
          break;
        case 3:
          buffer = new byte[dims[0]][dims[1]][dims[2]];
          send_mod.send_3Dbyte_array((byte[][][])buffer);
          break;
      }
      break;
      case T_SHORT:
      switch(ndims){
        case 0:
          short num = send_mod.send_short();
          buffer = new Short(num);
          break;
        case 1:
          buffer = new short[dims[0]];
          send_mod.send_1Dshort_array((short[])buffer);
          break;
        case 2:  
          buffer = new short[dims[0]][dims[1]];
          send_mod.send_2Dshort_array((short[][])buffer);
          break;
        case 3:
          buffer = new short[dims[0]][dims[1]][dims[2]];
          send_mod.send_3Dshort_array((short[][][])buffer);
          break;
      }
      break;
    }
    */



}
  


