package webflow.modules.demo.SciVis;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

/**
* For java_mser
*/
public class 
SciVisData_mser implements SciVisData 
{

  int command = 12;
  String name = null;
  int ntime ;
  double[] time ;
  double[][] x;
  double[][] fx;
  int[] nx ;

  /**
  */
  public
  SciVisData_mser() {};

  /**
  */
  public
  SciVisData_mser(String _name, int _ntime, double[] _time, 
               int[] _nx, double[][] _x, double[][] _fx) 
  {
      int i,j;

      name = new String(_name);
      ntime = _ntime;
      
      if(ntime>0)
      {
         time = new double[ntime];
         nx   = new int[ntime];

         x    = new double[ntime][];
         fx   = new double[ntime][];

         for(i=0;i<ntime;i++)
         {
            time[i] = _time[i];
              nx[i] = _nx[i]; 

            if(nx[i]>0)
            {
                x[i] = new double[nx[i]]; 
               fx[i] = new double[nx[i]]; 
  
               for(j=0;j<nx[i];j++)
               {
                   x[i][j] = _x[i][j];
                  fx[i][j] = _fx[i][j];

               }// end of for

            }// end of if 

         }// end of for

      }// end of if

  }

  /**
  */
  public void
  setWinName(String _name)
  { name = new String(_name); }

  /**
  */
  public void
  setTime(float _time)
  { time[0] = _time; }


  /**
  * Assuming that the Command is already consumed.
  */
  public int 
  readFrom(DataInputStream in) throws IOException
  {
     int i, j, retVal = 0;

     /** Read the number of characters in the name */
     int len = in.readInt();

     /** Allocate enough space for reading */
     byte[] buffer = new byte[len];

     /** Read the name */
     in.read(buffer);

     /** Define the name */
     name = new String(buffer);


     /** Read the number of rep */
     ntime = in.readInt();

     if(ntime>0)
     {
        time = new double[ntime];
        nx   = new int[ntime];
        x    = new double[ntime][];
        fx   = new double[ntime][];

     }// end of if

     for(i=0;i<ntime;i++)
     { 

        /** Read the time */
        time[i] = (double)in.readFloat();

        /** Read the number of elements */
        nx[i] = in.readInt();

        if(nx[i]>0)
        {
           /** Define the elements */
           x[i] = new double[nx[i]];
           fx[i] = new double[nx[i]];
        }

        /** Read the elements */
        for(j=0;j<nx[i];j++)
        {
            x[i][j] = in.readDouble();
           fx[i][j] = in.readDouble();

        }// end of for

     }// end of for

     retVal = 1;

     return retVal;

  }// end of readFrom()

  /**
  */
  public int 
  writeTo(DataOutputStream out) throws IOException
  {
     int i, j, retVal = 0;

     /** Write Command */
     out.writeInt(command);

     if(name==null) name = new String("Standard#10");

     /** Write length of The Name of the Window */
     out.writeInt(name.length());

     /** Write The Name of the Window */
     out.writeBytes(name);

     out.writeInt(ntime);

     for(i=0;i<ntime;i++)
     {
     
        /** Write Time */
        out.writeFloat((float)time[i]);

        /** Write Number of elements */
        out.writeInt(nx[i]);

        /** Write elements */
        for(j=0;j<nx[i];j++)
        {
           out.writeFloat((float)x[i][j]);
           out.writeFloat((float)fx[i][j]);

        }// end of for

     }// end of for

     retVal = 1;

     return retVal;

  }// end of writeTo()

}// end of SciVisData10

