package webflow.modules.demo.SciVis;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

/**
* For java_ser
*/
public class 
SciVisData_ser implements SciVisData 
{

  int command = 10;
  String name = null;
  double time ;
  double[] x;
  double[] fx;
  int nx = 0;

  /**
  */
  public
  SciVisData_ser() {};

  /**
  */
  public
  SciVisData_ser(String _name, double _time, int _nx, 
               double[] _x, double[] _fx) 
  {

      name = new String(_name);
      time = _time;
      nx   = Math.min(Math.min(_x.length,_fx.length),_nx);
     
      if(nx>0)
      {
          x = new double[nx];
         fx = new double[nx];

         for(int i=0;i<nx;i++)
         {
             x[i] = _x[i];
            fx[i] = _fx[i];

         }// end of for

      }// end of if

  }

  /**
  */
  public void
  setWinName(String _name)
  { name = new String(_name); }

  /**
  */
  public void
  setTime(float _time)
  { time = _time; }


  /**
  * Assuming that the Command is already consumed.
  */
  public int 
  readFrom(DataInputStream in) throws IOException
  {
     int retVal = 0;

     /** Read the number of characters in the name */
     int len = in.readInt();

     /** Allocate enough space for reading */
     byte[] buffer = new byte[len];

     /** Read the name */
     in.read(buffer);

     /** Define the name */
     name = new String(buffer);

     /** Read the time */
     time = (double)in.readFloat();

     /** Read the number of elements */
     nx = in.readInt();

     /** Define the elements */
     x = new double[nx];
     fx = new double[nx];

     /** Read the elements */
     for(int i=0;i<nx;i++)
     {
         x[i] = in.readDouble();
        fx[i] = in.readDouble();

     }// end of for

     retVal = 1;

     return retVal;

  }// end of readFrom()

  /**
  */
  public int 
  writeTo(DataOutputStream out) throws IOException
  {
     int retVal = 0;

     /** Write Command */
     out.writeInt(command);

     if(name==null) name = new String("Standard#10");

     /** Write length of The Name of the Window */
     out.writeInt(name.length());

     /** Write The Name of the Window */
     out.writeBytes(name);

     /** Write Time */
     out.writeFloat((float)time);

     /** Write Number of elements */
     out.writeInt(nx);

     /** Write elements */
     for(int i=0;i<nx;i++)
     {
        out.writeFloat((float)x[i]);
        out.writeFloat((float)fx[i]);

     }// end of for

     retVal = 1;

     return retVal;

  }// end of writeTo()

}// end of SciVisData10

