package webflow.modules.demo.SciVis;

import java.io.*;
import java.net.*;
import java.lang.*;

public class 
SciVisInfoReader implements Runnable
{

   Socket aSocket = null;
   DataInputStream  dis = null;
   DataOutputStream dos = null;
   static final boolean DEBUG = true;
   ServerSocket listener = null;

   Thread runner;

   SciVisViewer viewer = null;

   boolean bool;

   public 
   SciVisInfoReader(ServerSocket _listener, SciVisViewer _view)
   {
      listener = _listener;
      viewer = _view;
      start();

   }// end of constructor

   public void 
   start()
   {
      if(DEBUG) System.out.println("start() of SciVisInfoReader.java ");

      if(runner==null)
      {
         runner= new Thread(this);
         runner.start();

      }// end of if

      if(DEBUG) System.out.println("end of start() of SciVisInfoReader.java ");

   }// end of start

   /**
   * Reads the SciVis Hostname and Port Number from the client and
   * updates this values in the SciVis Filter Program.
   * <p>
   * Package Description : <br>
   *  <int> length of the Hostname <br>
   *  <byte,....> Hostname in terms of bytes <br>
   *  <int> Port Number
   */
   public void 
   run()
   {
     if(DEBUG) System.out.println("Getting Stream");
     boolean cnt = true;

     try
     { 

         if(DEBUG) System.out.println(" I am waiting for Socket Connection ");

         Socket aSocket = listener.accept();

         if(DEBUG) System.out.println(" I got the Socket Connection ");

         dis = new DataInputStream(aSocket.getInputStream());

         dos = new DataOutputStream(aSocket.getOutputStream());

         while(cnt)
         {
            /* Length of the host Name */
            int len = dis.readInt();

            if(DEBUG) System.out.println(" I got len as "+len);

            /* Read host.name */
            byte[] buf = new byte[len];
            dis.readFully(buf);

            String SciVisHost = new String(buf);

            if(DEBUG) System.out.println(" I got SciVisHost as "+SciVisHost);

            /* portNumber */
            int SciVisPort = dis.readInt();

            if(DEBUG) System.out.println(" I got SciVisPort as "+SciVisPort);

            /** Set the Host Name and the Port Number */
            if(viewer!=null) 
            {
               viewer.setSciVisHostName(SciVisHost);
               viewer.setSciVisPort(SciVisPort);
               
               writeToConfig(SciVisHost,SciVisPort,"SciVis.config"); 

            }// end of if

         }// end of while	

      } catch(IOException e)
        { System.out.println(e); }

  }

  void
  writeToConfig(String SVHost,int SVPort, String CNFName) 
  {
     if(DEBUG) System.out.println(" I am in writeToConfig() in SciVisInfoReader.java ");
     try
     {
       PrintStream dout = new PrintStream(new FileOutputStream(CNFName));
       dout.println(SVHost);
       dout.print(SVPort);

       dout.close();
       if(DEBUG) System.out.println(" I wrote in writeToConfig() in SciVisInfoReader.java ");

     } catch(IOException ioe)
       { ioe.printStackTrace(); }
  }// end of writeToConfig()

  /**
  * Sends the data
  */
  public void 
  send(int val)
  {
      try
      {
         if(DEBUG) System.out.println("WRITING VALUES");

         if(dos!=null) dos.writeInt(val);

      } catch(IOException e)
       { System.out.println(e); }

  }// end of send()
  
    
  /**
  * stop the thread.
  * close the socket.
  */
  public void 
  stop()
  {
    /********************/
    /** Stop the Thread */
    /********************/
    if(runner!=null)
    {
         runner.stop();
         runner=null;

    }// end of if

    /***************************************/
    /** Close the frame on client's window */
    /***************************************/
    send(0);

    /*********************/
    /** Close the Socket */
    /*********************/
    try
    {
       if(aSocket!=null) aSocket.close();

    } catch(IOException e) 
      { System.out.println(e); }
 

    /***************************/
    /** Close the ServerSocket */
    /***************************/
    try
    {
       listener.close();
    } catch(IOException e) 
      { System.out.println(e); }
 

  }// end of stop()

}// end of class SciVisInfoReader
