package webflow.modules.demo.SciVis;

import java.io.*;
import java.lang.*;
import java.net.*;

import webflow.backend.Port;


/**
* This port allows us to send the data with/without Window
* Names.
*
* Updates <br>
* <ol>
*  <li> (Nov.11.1997) the window name.
* </ol>
* @date October 13, 1997
*/
public class 
SciVisPlotPort extends Port
{
  static final boolean DEBUG = true;
  DataInputStream is;
  DataOutputStream os;
  double d;

  public void 
  send(Object data1)
  {
     System.out.println(" It does nothing!!!!!");
  }

 void
 convertDoubleToByteArray(double val, byte[] ret)
 {
    long vals = Double.doubleToLongBits(val);
    
    for(int i=0;i<8;i++)
    {
        ret[i] = (byte)(vals & 0x00000000000000ff);
        vals   = vals >> 8;
    }
 } 

 public void 
 send2(int len, double[] x, double[] y)
 {
   
    if(DEBUG)
       System.out.println(" HELLO I am in SEND2(). I will send "+len+" elements !!!!@@@@@@");

    try
    {
        ByteArrayOutputStream bos = new ByteArrayOutputStream();
        
        DataOutputStream dos = new DataOutputStream(bos);

        /** write Number of Chracters in the Window Name */
        dos.writeInt(0);

        dos.writeInt(len);

        for(int i=0;i<len;i++)
        { 
           dos.writeDouble(x[i]);
           dos.writeDouble(y[i]); 

        }// end of for
  
        os = new DataOutputStream(getSocket().getOutputStream());
        os.writeInt(bos.size());
        os.write(bos.toByteArray(),0,bos.size());

    } catch(IOException e){}

    if(DEBUG)
       System.out.println(" I sent "+len+" elements of the data in SEND2()!!!!@@@@@@");

 }// end of send2()

 public void 
 send_1d(int len, double[] x, double[] y)
 {
   
    if(DEBUG)
       System.out.println(" HELLO I am in SEND2(). I will send "+len+" elements !!!!@@@@@@");

    try
    {
        ByteArrayOutputStream bos = new ByteArrayOutputStream();
        
        DataOutputStream dos = new DataOutputStream(bos);

        /** write Number of Chracters in the Window Name */
        dos.writeInt(0);

        dos.writeInt(len);

        for(int i=0;i<len;i++)
        { 
           dos.writeDouble(x[i]);
           dos.writeDouble(y[i]); 

        }// end of for
  
        os = new DataOutputStream(getSocket().getOutputStream());
        os.writeInt(bos.size());
        os.write(bos.toByteArray(),0,bos.size());

    } catch(IOException e){}

    if(DEBUG)
       System.out.println(" I sent "+len+" elements of the data in SEND2()!!!!@@@@@@");

 }// end of send2()

 /**
 * Sends 1D data with Window Name
 */ 
 public void 
 send_1d(String windowName, int len, double[] x, double[] y)
 {
   
    if(DEBUG)
       System.out.println(" HELLO I am in send_1d(). I will send "+len+" elements !!!!@@@@@@");

    try
    {
        ByteArrayOutputStream bos = new ByteArrayOutputStream();
        
        DataOutputStream dos = new DataOutputStream(bos);

        /** write Number of Chracters in the Window Name */
        dos.writeInt(windowName.length());

        /** write the Window Name */
        dos.write(windowName.getBytes());

        dos.writeInt(len);

        for(int i=0;i<len;i++)
        { 
           dos.writeDouble(x[i]);
           dos.writeDouble(y[i]); 

        }// end of for
  
        os = new DataOutputStream(getSocket().getOutputStream());
        os.writeInt(bos.size());
        os.write(bos.toByteArray(),0,bos.size());

    } catch(IOException e){}

    if(DEBUG)
       System.out.println(" I sent "+len+" elements of the data in  send_1d()!!!!@@@@@@");

 }// end of send_1d()

 /**
 * Sends 2D data without Window Name
 */
 public void 
 send_2d(int len, double fxy[][])
 {
   
    if(DEBUG)
       System.out.println(" HELLO I am in send_2d(). I will send "+len+" elements !!!!@@@@@@");

    try
    {
        ByteArrayOutputStream bos = new ByteArrayOutputStream();
        
        DataOutputStream dos = new DataOutputStream(bos);

        /** write Number(0) of Characters in the Window Name */
        dos.writeInt(0);

        dos.writeInt(len);

        for(int i=0;i<len;i++)
        { 
           dos.writeDouble(fxy[i][0]);
           dos.writeDouble(fxy[i][1]);
           dos.writeDouble(fxy[i][2]);
           //System.out.print(i+" + "); 

        }// end of for
  
        os = new DataOutputStream(getSocket().getOutputStream());
        os.writeInt(bos.size());
        os.write(bos.toByteArray(),0,bos.size());

    } catch(IOException e){}

    if(DEBUG)
       System.out.println(" I sent "+len+" elements of the data in send_2d()!!!!@@@@@@");

 }// end of send_2d()

 /**
 * Sends 2D data with Window Name
 */
 public void 
 send_2d(String windowName, int len, double fxy[][])
 {
    if(DEBUG)
       System.out.println(" I sent "+len+" elements of the data in send_2d()!!!!@@@@@@ "+windowName);
   
    try
    {
        ByteArrayOutputStream bos = new ByteArrayOutputStream();
        
        DataOutputStream dos = new DataOutputStream(bos);

        /** write Number of Chracters in the Window Name */
        dos.writeInt(windowName.length());

        /** write the Window Name */
        dos.write(windowName.getBytes());

        /** write size of array */
        dos.writeInt(len);

        for(int i=0;i<len;i++)
        { 
           dos.writeDouble(fxy[i][0]);
           dos.writeDouble(fxy[i][1]);
           dos.writeDouble(fxy[i][2]);

        }// end of for
  
        os = new DataOutputStream(getSocket().getOutputStream());
        os.writeInt(bos.size());
        os.write(bos.toByteArray(),0,bos.size());

    } catch(IOException e){}

    if(DEBUG)
       System.out.println(" I sent "+len+" elements of the data in send_2d()!!!!@@@@@@ "+windowName);

 }// end of send_2d()

 /**
 * Sends the bbser2d data without Window Name
 */
 public void 
 send_bbser2d(double[] bb, int nx, int ny, double fxy[])
 {
   
    System.out.print(" HELLO I am in send_bbser2d(). I will send nx "+nx);
    System.out.println(" ny "+ny+" elements !!!!@@@@@@");

    try
    {
        ByteArrayOutputStream bos = new ByteArrayOutputStream();
        
        DataOutputStream dos = new DataOutputStream(bos);

        dos.writeInt(0);

        dos.writeInt(nx);
        dos.writeInt(ny);

        dos.writeFloat((float)bb[0]);
        dos.writeFloat((float)bb[1]);
        dos.writeFloat((float)bb[2]);
        dos.writeFloat((float)bb[3]);

        for(int i=0;i<nx*ny;i++) dos.writeDouble(fxy[i]);
  
        os = new DataOutputStream(getSocket().getOutputStream());
        os.writeInt(bos.size());
        os.write(bos.toByteArray(),0,bos.size());

    } catch(IOException e){}

    System.out.println(" I sent "+(nx*ny)+" elements of the data in send_bbser2d()!!!!@@@@@@");

 }// end of send_bbser2d()

 /**
 * Sends the bbser2d data with Window Name
 */
 public void 
 send_bbser2d(String windowName, double[] bb, int nx, int ny, double fxy[])
 {
   
    if(DEBUG)
    {
       System.out.print(" HELLO I am in send_bbser2d(). I will send nx "+nx);
       System.out.println(" ny "+ny+" elements !!!!@@@@@@");
    }

    try
    {
        ByteArrayOutputStream bos = new ByteArrayOutputStream();
        
        DataOutputStream dos = new DataOutputStream(bos);

        dos.writeInt(windowName.length());

        dos.write(windowName.getBytes());

        dos.writeInt(nx);
        dos.writeInt(ny);

        dos.writeFloat((float)bb[0]);
        dos.writeFloat((float)bb[1]);
        dos.writeFloat((float)bb[2]);
        dos.writeFloat((float)bb[3]);

        for(int i=0;i<nx*ny;i++) dos.writeDouble(fxy[i]);
  
        os = new DataOutputStream(getSocket().getOutputStream());
        os.writeInt(bos.size());
        os.write(bos.toByteArray(),0,bos.size());

    } catch(IOException e){}

    System.out.println(" I sent "+(nx*ny)+" elements of the data in send_bbser2d()!!!!@@@@@@");

 }// end of send_bbser2d()

 /**
 * Sends the 2D data in ser2d format without Window Name 
 */
 public void 
 send_ser2d(int len, double fxy[][])
 {
   
    System.out.println(" HELLO I am in send_ser2d(). I will send "+len+" elements !!!!@@@@@@");

    try
    {
        ByteArrayOutputStream bos = new ByteArrayOutputStream();
        
        DataOutputStream dos = new DataOutputStream(bos);

        dos.writeInt(0);

        dos.writeInt(len);

        for(int i=0;i<len;i++)
        { 
           dos.writeDouble(fxy[i][0]);
           dos.writeDouble(fxy[i][1]);
           dos.writeDouble(fxy[i][2]);
           //System.out.print(i+" + "); 

        }// end of for
  
        os = new DataOutputStream(getSocket().getOutputStream());
        os.writeInt(bos.size());
        os.write(bos.toByteArray(),0,bos.size());

    } catch(IOException e){}

    System.out.println(" I sent "+len+" elements of the data in send_ser2d()!!!!@@@@@@");

 }// end of send_ser2d()

 /**
 * Sends the 2D data in ser2d format with Window Name 
 */
 public void 
 send_ser2d(String windowName, int len, double fxy[][])
 {
   
    System.out.println(" HELLO I am in send_ser2d(). I will send "+len+" elements !!!!@@@@@@");

    try
    {
        ByteArrayOutputStream bos = new ByteArrayOutputStream();
        
        DataOutputStream dos = new DataOutputStream(bos);

        dos.writeInt(windowName.length());

        dos.write(windowName.getBytes());

        dos.writeInt(len);

        for(int i=0;i<len;i++)
        { 
           dos.writeDouble(fxy[i][0]);
           dos.writeDouble(fxy[i][1]);
           dos.writeDouble(fxy[i][2]);

        }// end of for
  
        os = new DataOutputStream(getSocket().getOutputStream());
        os.writeInt(bos.size());
        os.write(bos.toByteArray(),0,bos.size());

    } catch(IOException e){}

    System.out.println(" I sent "+len+" elements of the data in send_ser2d()!!!!@@@@@@");

 }// end of send_ser2d()

 public void 
 send21(int len, double[] x, double[] y)
 {
   
    System.out.println(" HELLO I am in SEND2(). I will send "+len+" elements !!!!@@@@@@");

    send_1d(len,x,y);

    /*
    try
    {
        DataOutputStream os = new DataOutputStream(getSocket().getOutputStream());

        os.writeInt(len);

        for(int i=0;i<len;i++)
        { 
           os.writeDouble(x[i]);
           os.writeDouble(y[i]); 
           //System.out.print(i+" + "); 

        }// end of for
  
        //os.flush();

    } catch(IOException e){}
    */

    System.out.println(" I sent "+len+" elements of the data in SEND2()!!!!@@@@@@");

 }// end of send2()

 public Object 
 receive()
 {
     System.out.println(" It does nothing!!!!!");
     return null;
 }

 
}// end of SciVisPlotPort

