package webflow.modules.demo.SciVis;

// We need Port Definition 
import webflow.backend.*;

import java.net.*;
import java.io.*;
import java.lang.*;
 
/**
* Reads 2D array and writes java_ser parameters of the SciVis
*/
public class 
SciVisPort1D_ser extends Port
                 implements SciVisViewer
{
  DataInputStream is;
  DataOutputStream os;

  SciVisData1D_ser Sdata;
  boolean ready = false;

  String SciVisHostName = null;
  int SciVisPort = -1;

  String winName = null;
  float wTime = 0; 

  /**
  */
  public void 
  setSciVisHostName(String _SciVisHostName)
  {
      SciVisHostName = new String(_SciVisHostName);

  }// setSciVisHostName()

  /**
  */
  public String 
  getSciVisHostName()
  {
      return ( SciVisHostName != null ? new String(SciVisHostName) : null ) ;

  }// setSciVisHostName()

  /**
  */
  public int 
  getSciVisPort()
  {
      return SciVisPort;

  }// getSciVisPort()

  /**
  */
  public void 
  setSciVisPort(int _SciVisPort)
  {
      SciVisPort = _SciVisPort;

  }// setSciVisPort()

  /**
  */
  public void 
  setTime(float _time) 
  { wTime = _time; }

  /**
  */
  public void 
  setWinName(String _name) 
  { winName = new String(_name); }

  /**
  * Sends the SciVisData object
  */
  public void 
  send(Object data ) 
  {
    System.out.println("I am in send() of SciVisPort1D_ser.java ");

    //Sdata = prepareCustom(); // Test 
    //Sdata = prepareCustom12(); // Test 
    System.out.println(" SciVisHostName "+SciVisHostName);
    System.out.println(" SciVisPort "+SciVisPort);
    System.out.println(" ready "+(ready?"TRUE":"FALSE"));

    if(ready==false || SciVisHostName == null || SciVisPort == -1 || data == null ) return;

    System.out.println("I will send of SciVisPort1D_ser.java ");

    Sdata = (SciVisData1D_ser) data;
    Socket s = null;
    DataOutputStream out = null;

    try
    {
          s =  new Socket(SciVisHostName,SciVisPort);
        out = new DataOutputStream(new BufferedOutputStream(s.getOutputStream()));

        Sdata.setWinName(winName);
        Sdata.setTime(wTime);

        System.out.println( "I will send the data to SciVis -- SciVisPort1D_ser.java ");
        /** Tell data to write itself to the OutputStream */
        Sdata.writeTo(out);
        System.out.println( "I sent the data to SciVis -- SciVisPort1D_ser.java win "+winName+" time "+wTime);

        out.close();

        ready = false; 

    } catch(IOException ioe) {}

    System.out.println( "send() is finished -- SciVisPort1D_ser.java ");

  }// end of send()
  

  /**
  * Receives the SciVisData object.
  * Returns NULL if it can read the expected SciVisData
  */
  public Object 
  receive()
  {
    SciVisData ret = null;

    System.out.println( "receive in SciVisPort1D_ser.java ");

    if(getSocket()!=null) 
    { 

      try
      {

        //out = new DataOutputStream(new BufferedOutputStream(s.getOutputStream()));
         is =  new DataInputStream(new BufferedInputStream(getSocket().getInputStream()));
         ret = new SciVisData1D_ser(); 

         if(ret.readFrom(is)!=1) ret = null;
         System.out.println( "I read the data -- SciVisPort1D_ser.java ");

         //is.close();
         ready = true; 

         /** Write Confirmation */
         os =  new DataOutputStream(getSocket().getOutputStream());
         os.writeInt(0);
         //os.close();
         System.out.println( "I wrote confirm -- SciVisPort1D_ser.java ");


      } catch(IOException ioe)
        { System.out.println("a1"); ret=null; }
        
    } else System.out.println( "Socket is EMPTY! receive in SciVisPort1D_ser.java ");

    return ret;

  }// end of receive()

  /**
  */
  public void
  closeSocket()
  {
     try
     {
       if(getSocket()!=null)  getSocket().close();

     } catch(IOException ioe) {}

  }// end of closeSocket()

}// end of SciVisPort1D_Ser()

