package webflow.modules.demo.SciVis;

// We need Port Definition 
import webflow.backend.*;
import webflow.modules.demo.SciVis.*;

import java.net.*;
import java.io.*;
import java.lang.*;
 
/**
* Reads 2D array and writes java_ser parameters of the SciVis
*/
public class 
SciVisPort2D_bbser2d extends Port
                 implements SciVisViewer
{
  DataInputStream is;
  DataOutputStream os;

  SciVisData2D_bbser2d Sdata;
  boolean ready = false;

  String SciVisHostName = null;
  int SciVisPort = -1;

  String winName = null;
  float wTime = 0; 

  /**
  */
  public void 
  setSciVisHostName(String _SciVisHostName)
  {
      SciVisHostName = new String(_SciVisHostName);

  }// setSciVisHostName()

  /**
  */
  public String 
  getSciVisHostName()
  {
      return ( SciVisHostName != null ? new String(SciVisHostName) : null ) ;

  }// setSciVisHostName()

  /**
  */
  public int 
  getSciVisPort()
  {
      return SciVisPort;

  }// getSciVisPort()

  /**
  */
  public void 
  setSciVisPort(int _SciVisPort)
  {
      SciVisPort = _SciVisPort;

  }// setSciVisPort()

  /**
  */
  public void 
  setTime(float _time) 
  { wTime = _time; }

  /**
  */
  public void 
  setWinName(String _name) 
  { winName = new String(_name); }

  /**
  */
  public SciVisData
  prepareCustom()
  {
     ready = true;
     String name = new String("Voyager#1");
     double time = 10.1;
     int nx   = 10;
     double[] x = new double[10];
     double[] fx = new double[10];

     for(int i=0;i<10;i++)
     {
        x[i] = (Math.PI / 10) * i;
        fx[i] = Math.sin(x[i]);
        //System.out.println(" sin("+x[i]+") = "+fx[i]);
     } 
     
     return new SciVisData_ser(name,time,nx,x,fx);
     
  }// end of prepareCustom()

  /**
  */
  public SciVisData
  prepareCustom12()
  {
     ready = true;
     String name = new String("Voyager#2");
     int    ntime = 2;
     double[] time = new double[2];
     int[] nx   = new int[2];
     double[][] x = new double[2][10];
     double[][] fx = new double[2][10];

     time[0] = 10.1; 
     time[1] = 9.1; 
     nx[0] = 10; 
     nx[1] = 10; 

     for(int i=0;i<nx[0];i++)
     {
        x[0][i] = (Math.PI / nx[0]) * i;
        fx[0][i] = Math.sin(x[0][i]);
        //System.out.println(" sin("+x[0][i]+") = "+fx[0][i]);
     } 

     for(int i=0;i<nx[1];i++)
     {
        x[1][i] = (Math.PI / nx[1]) * i;
        fx[1][i] = Math.cos(x[1][i]);
        //System.out.println(" sin("+x[1][i]+") = "+fx[1][i]);
     } 
     

     return new SciVisData_mser(name,ntime,time,nx,x,fx);
     
  }// end of prepareCustom12()

  /**
  * Sends the SciVisData object
  */
  public void 
  send(Object data ) 
  {
    System.out.println("I am in send() of SciVisPort2D_ser2d.java ");

    //Sdata = prepareCustom(); // Test 
    //Sdata = prepareCustom12(); // Test 
    System.out.println(" SciVisHostName "+SciVisHostName);
    System.out.println(" SciVisPort "+SciVisPort);
    System.out.println(" ready "+(ready?"TRUE":"FALSE"));

    if(ready==false || SciVisHostName == null || SciVisPort == -1 || data == null ) return;

    //  System.out.println("I will send of SciVisPort2D_ser.java ");

    Sdata = (SciVisData2D_bbser2d) data;
    Socket s = null;
    DataOutputStream out = null;

    try
    {
          s = new Socket(SciVisHostName,SciVisPort);
        out = new DataOutputStream(new BufferedOutputStream(s.getOutputStream()));

        Sdata.setWinName(winName);
        Sdata.setTime(wTime);

	//      System.out.println( "I will send the data to SciVis -- SciVisPort2D_ser2d.java ");
        /** Tell data to write itself to the OutputStream */
        Sdata.writeTo(out);
        System.out.println( "I sent the data to SciVis -- SciVisPort2D_ser2d.java win "+winName+" time "+wTime);

        out.close();

        ready = false; 

    } catch(IOException ioe) {}

    //  System.out.println( "send() is finished -- SciVisPort2D_ser2d.java ");

  }// end of send()
  

  /**
  * Receives the SciVisData object.
  * Returns NULL if it can read the expected SciVisData
  */
  public Object 
  receive()
  {
    SciVisData ret = null;

    System.out.println( "receive in SciVisPort2D_ser2d.java ");

    if(getSocket()!=null) 
    { 

      try
      {

         is =  new DataInputStream(new BufferedInputStream(getSocket().getInputStream()));

         ret = new SciVisData2D_bbser2d(); 

         if(ret.readFrom(is)!=1) ret = null;
	 //      System.out.println( "I read the data -- SciVisPort2D_ser2d.java ");

         //is.close();
         ready = true; 

         /** Write Confirmation */
         os =  new DataOutputStream(getSocket().getOutputStream());
         os.writeInt(0);
         //os.close();
	 //      System.out.println( "I wrote confirm -- SciVisPort2D_ser2d.java ");


      } catch(IOException ioe)
        {
  System.out.println("a1");for (int l =0 ;l<1000;l++) System.out.println("a1"); ret=null; }
        
    } else System.out.println( "Socket is EMPTY! receive in SciVisPort2D_ser2d.java ");

    return ret;

  }// end of receive()

  public void
  closeSocket()
  {
     try
     {
       if(getSocket()!=null)  getSocket().close();

     } catch(IOException ioe) {}

  }// end of closeSocket()

}// end of SciVisPort2D_ser2d()

