package webflow.modules.demo.collab;

import webflow.modules.demo.image.*;
import java.awt.*;

/**
 * A Canvas that displays an image.<p>
 *
 * update() is overridden to call paint() directly, thus 
 * bypassing the default implementation of update() which 
 * erases the background of the canvas before calling paint().
 * This eliminates nasty flashing.<p>
 *
 * @author  Shrideep Pallickara
 *
 */
class ImageCanvas extends Canvas {
    public Image image;

    public ImageCanvas(Image image) {
        this.image = image;
        resize(300,300);
    }
    public void paint(Graphics g) {
             Dimension d = size();
             int x = (d.width - image.getWidth(null)) / 2;
             int y = (d.height - image.getHeight(null)) / 2;
             g.drawImage(image,x,y, this);
    }
    public void update(Graphics g) {
        paint(g);
    }
}
