package webflow.modules.demo.collab;

import webflow.modules.demo.image.*;

import SharedData.*;
import java.awt.*;
import java.applet.Applet;
import java.awt.image.*;



class
ImageToolConsumer2 implements ChannelConsumer, ImageToolDebugFlags {

    /** The name of this channel consumer. */
    protected String name;

    /** The location to write all messages received. */
    TextArea messageArea;


    public
    ImageToolConsumer2(String name, TextArea messageArea) {
	if (ImageToolConsumer_Debug) {
	    System.out.println("ImageToolConsumer: constructor.");
	}

	this.name = name;
	this.messageArea = messageArea;
    }


    public synchronized void
    dataReceived(Data data) {
        String  message;
        int     position   = 0;
	int     priority   = data.getPriority();
	String  senderName = data.getSenderName();
        Channel channel    = data.getChannel();
        byte[]  theData    = data.getData();

        if (ImageToolConsumer_Debug) {
            System.out.println("ImageToolConsumer: dataReceived " +
                               " Priority "    + priority +
                               " Channel "     + channel +
                               " Sender name " + senderName +
                               " Data "        + theData);
        }

/* Construct message and output it to the end of the message area. */

        message = senderName + ": " + new String(theData, 0) + "\n";
	position = messageArea.getText().length(); 
        messageArea.insertText(message, position); 
    }
}
