/***************************************************************************************
*  Class plotdata3dsp generates the 3-D data  sends this data to   		      *
*  the plotfilter3dsp module							      *
****************************************************************************************/
package webflow.modules.demo.image;

import webflow.frontend.*;
import webflow.backend.*;
import gjt.filter.*;
import java.awt.image.*;
import gjt.*;
import java.awt.*;
import java.net.*;
import java.io.*;
import java.lang.*;


public class plotdata3dsp implements Module
{
	ServerSocket listener;
        ServerSocket sender;
	Double pixel_value;
	DataInputStream dis;
	double temp1;
	IntData val;
Math m;
double[] Ypixels;
double[] Xpixels;
double[] Zpixels;
int size=20;

double sigma=20f;
double offset=size/2.0f;
double ampl=0.01f;
float fraction=1.25f;
String hostName;
int portNumber;
DataOutputStream dos;
boolean bool=false;
PlotPort p1;
int Pt;
float t=0;
double temp;


//initialize method of the module
public MetaModule initialize(){
Xpixels=new double[size];
Ypixels=new double[size];
Zpixels=new double[size];  
MetaModule mm  = new MetaModule("mm");
p1= new PlotPort();
mm.putPortID(p1.getPortID());
return(mm);
}
	public void run(){
	try
       {
           Socket aSocket = p1.getSocket();	
           dis = new DataInputStream(aSocket.getInputStream());
	 
	   for(int l=0;l<100;l++)
           {
            for(int i=0;i<10;i++) produce_senddata(fraction);
            for(int i=0;i<10;i++) produce_senddata(1f/fraction);
          } 
            
 	}
	catch(IOException e)
	{}
		}

//generate the X,Y,Z values for the 3-D data
public void produce_senddata(float iter)
{
 double dummy;
 
   for(int i=0;i<size;i++) Xpixels[i]=1f *i;
  for(int i=0;i<size;i++) Ypixels[i]=1f *i;
  for(int i=0;i<size;i++) Zpixels[i]=1f *i;
  double[][]fxyz=new double[size*size*size][4];
 
 
    sigma=sigma*iter;
    for(int i=0;i<size;i++)
    {
     for(int j=0;j<size;j++)
     {
      for(int k=0;k<size;k++)
      {
       fxyz[(((i*size)+j)*size)+k][0]=Xpixels[i];
       fxyz[(((i*size)+j)*size)+k][1]=Ypixels[j];
       fxyz[(((i*size)+j)*size)+k][2]=Zpixels[k];
       fxyz[(((i*size)+j)*size)+k][3]=calc(Xpixels[i],Ypixels[j],Zpixels[k],i,j,k,sigma);

	}
       }
      }

      p1.send_3d(size*size*size,fxyz); 	//send the 3-D data
      confirm(0);
      for(int i=0;i<5000;i++) dummy = Math.sqrt(i*0.997898);

}



//generate the value of the function for the 3-D data
double calc(double x,double y,double z,int i,int j,int k, double sigma)
{
 double a=2.0;
 double ret=ampl*(Math.sin(0.1f*(x+k)))*(Math.exp(-(Math.pow((y-offset),a))/sigma))*(Math.exp(-(Math.pow((z-offset),a))/sigma));
 return ret;
}


//destroy method of the module
public void destroy(){

if(p1!=null) p1.destroyPort();
	}

 

// confirms that the filter module has received the data  by reading an integer
 void confirm(int flag){
    int readflag ;
  try{
  do
      { 
        readflag = dis.readInt();


      } while(readflag!=flag);
 }
catch(IOException e){
System.out.println(e);
}
 }	
	

public void stop(){}               

}	
	



