package webflow.modules.demo.io;

import webflow.frontend.*;
import webflow.backend.*;
import webflow.modules.*;
import java.awt.image.*;
import java.lang.*;
import gjt.filter.*;
import java.net.*;
import java.io.*;

/* 
 * This module transmits the image data which it receives from the viewer
 * module
 */

public class InputModule implements Module {
 // Add port number of Server on which SessionManagerServlet is present
/*
String JeevPortNum=new String("9080/filters"); 
 ImgPort img;
*/
  ImgData imgdat;	
  //InputPort inport;
  OutputPort outport;
  ServerSocket listener;
  Socket aSocket;
  String hostName;
  int portNumber;
  DataInputStream dis;
  DataOutputStream dos;
  Diagnostic diag;
	
  public MetaModule initialize() {
    // Load the image.
    MetaModule mm = new MetaModule("Input Module ");
    int i;
    diag = new Diagnostic("inModule.diag");
    diag.activate(true);
    diag.write("diagnostic activated");
//    img=new ImgPort();
    //inport = new InputPort("ImgData");
    outport = new OutputPort("ImgData");
//    mm.putPortID(img.getPortID());
   // mm.putPortID(inport.getPortID());
    mm.putPortID(outport.getPortID());
    try{
      InetAddress local = java.net.InetAddress.getLocalHost();
      hostName = local.getHostName();
      // open new server socket
      listener = new ServerSocket(0);
      portNumber = listener.getLocalPort();
      diag.write("listener socket activated");
    }catch(UnknownHostException e){System.out.println(e);}
    catch(IOException e){System.out.println(e);}
// Html Code to Display Applet 

    String htmlString=new String("CODE = \"webflow.modules.demo.io.InputApplet.class\"  WIDTH=300 HEIGHT=300>\n<PARAM Name=Host");
    htmlString+=" VALUE=";
    htmlString+=hostName;
    htmlString+=">\n<PARAM NAME = portnum VALUE = ";
    htmlString+=String.valueOf(portNumber);
    htmlString+=">\n<PARAM Name=FName VALUE=Input>\n</APPLET>\n</P>\n";
    //System.out.println(htmlString);
    mm.setHTML(htmlString);
    //System.out.println("out");

    /*
    try{
      aSocket=listener.accept();

      diag.write("accepted connection");
      dos= new DataOutputStream(aSocket.getOutputStream());
      dis= new DataInputStream(aSocket.getInputStream());
      String fname= new String("TazzaLogo.gif");
      // dos.writeInt(fname.length());
      //dos.writeBytes(fname);
    } catch(IOException e) {System.out.println(e);}
    diag.write("confirmation 0 will be sent");
    confirm(0);
    diag.write("confirmation 0 sent");
    */
     
    diag.write("done initializing");
    //System.out.println("done initializing");
    return(mm);	
  }

  public ServerSocket getSocket() { return listener; }

  public void run(){

    try{
      aSocket=listener.accept();

      diag.write("accepted connection");
      dos= new DataOutputStream(aSocket.getOutputStream());
      dis= new DataInputStream(aSocket.getInputStream());
      String fname= new String("TazzaLogo.gif");
      // dos.writeInt(fname.length());
      //dos.writeBytes(fname);
    } catch(IOException e) {System.out.println(e);}
    diag.write("confirmation 0 will be sent");
    confirm(0);
    diag.write("confirmation 0 sent");
    

    while(true){
      get();
      diag.write("image received");
      sendImg();
      confirm(0);
      diag.write("confirmation 0 sent");
    }
  }	
  
	
  void  get(){
    try{
      int width=dis.readInt();
      int height=dis.readInt();
  
      diag.write("width = " + width + " height = " + height);
      //      System.out.println("w1 =" + width+"h=" + height);
      byte[] pixels = new byte[height*width*4];
      dis.readFully(pixels,0,width*height*4);
      imgdat= new  ImgData(pixels,width,height);
    } catch(IOException e){System.out.println(e);}	
    
    //System.out.println("Exiting get");
  }		
  
  public void sendImg(){
    // testing only
     diag.write("Sending image");
//    img.send(imgdat);
    outport.send(imgdat);
    diag.write("sent image");
  }
  
  public void destroy()
  {
    confirm(1);
    diag.write("confirmation 1 (die) sent");
    //System.out.println("confirmation 1 (die) sent");
    try{
      
      if(aSocket!=null) 
      {  aSocket.close();
         diag.write("socket closed");
         //System.out.println(" aSocket is closed");

      } else System.out.println(" aSocket is NULL ");

    } catch(IOException e)
      { System.out.println(e);
        e.printStackTrace(); 
      }

    //if(img!=null) img.destroyPort();
   // if(inport!=null) inport.destroyPort();
    if(outport!=null) outport.destroyPort();
    diag.write("image port destroyed, terminating");
    //System.out.println("image port destroyed, terminating");
  }

  void 
  confirm(int flag)
  {
    try
    {
       if(dos!=null) 
       {  dos.writeInt(flag);
          //System.out.println(" I wrote "+flag+" to the dos ");
       }// end of if

    } catch(IOException e)
      {  System.out.println(e);
         e.printStackTrace();
      }

  }// end of confirm()
  
  public void stop(){}

 
}


