package webflow.util;

/**
* QueueItem is used to implement a queue of events. 
*
*/
public class 
QueueItem extends Object
{
  /** Object stored in the queue item */
  Object obj;

  /** successor of the queue item     */
  QueueItem successor = null;

  /**
  * Creates a queue item that will store a given object. 
  * @param _obj the object stored
  */
  public 
  QueueItem(Object _obj) 
  {
    obj = _obj;
    successor = null;

  }// end of constructor

  /**
  * Returns the object stored in the queue item
  * @return the object 
  */
  public Object getObject() 
  {
    return obj;
  }// end of getObject()

  /**
  * Sets the successor of the queue item
  * @param next the successor
  */
  public void 
  setSuccessor(QueueItem _successor) 
  {
    successor = _successor;
  }// end of setSuccessor()

  /**
  * Returns the successor of the queue item
  * @return the successor
  */
  public QueueItem 
  getSuccessor() 
  {
    return successor;
  }// end of getSuccessor()

}// end of QueueItem
