
/*
 * @(#)ChatUser.java	1.1 97/02/27
 *
 * Copyright (c) 1993-1997 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You shall
 * not disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */

package webflow.modules.demo.collab;

import SharedData.*;
import java.awt.*;
import java.applet.Applet;
import java.io.*;
import java.net.*;
import webflow.frontend.*;
import webflow.backend.*;
/**
 * This is just a simple server/client based proof-of-concept
 * implementation to make sure that the Shared Data classes have
 * all the required API in them.
 *
 * It's based on the chat demonstration which is part of the
 * west-coast rmi distribution.
 *
 * @version     0.92 27 February 1997
 * @author      Rich Burridge
 */

public class
ChatUserA extends Frame implements  ChatDebugFlags,Runnable {
    Button    setNameButton;
    Button    sayButton;
    Button    signOffButton;
    TextField nameField;
    TextField typeField;
    TextArea  messageArea;
    ClientFrame cf;

    /** The name of this Client. */
    protected String name = null;

    /** The chat session that this client application will join. */
    private SharedData.Session session;

    /** The client that will be joining the session and channel. */
    private ChatClient client;

    /** The channel that this client application will use to send data. */
    private Channel channel;
 
    /** The consumer of all data sent over the channel. */
    private ChatConsumer chatConsumer;

    /** The data that will be sent over the channel. */
    private Data data;

    /** Indicates if the client is successfully connected to the server. */
    boolean connected = false;
/**Indicates whether the client has sent has sent confirmation or no*/
    int  bool=0; 

/* Default setup, will mostly be overriden by attributes. */

    public int     width       = 250;
    public int     height      = 250;
    public String  hostname    = "NULL";
    public int     hostport    = -1;
    public String  sessionType = "socket";
    public DataSocket s;
  /*  DataInputStream dis;
    DataOutputStream dos;
*/
   private Thread running = null;
    String hostName;
    int portNum;

	public ChatUserA(String host,int port){
		s=new DataSocket(host,port,this);
	}

    public synchronized void
    init() { 
//s=new DataSocket(hostName,portNum,this);
/*    hostName = getParameter("Host");

    portNum = Integer.parseInt(getParameter("portnum"));
    try{
      s=new DataSocket(hostName,portNum,this);
      System.out.println("Socket created " + hostName +" " + portNum);
    dis=new DataInputStream(s.getInputStream());
    dos= new DataOutputStream(s.getOutputStream());

    }catch(IOException e){System.out.println(e);};*/
        Panel p;
        Font               lbl;
        GridBagLayout      g;
        GridBagConstraints c;

        if (ChatUser_Debug) {
            System.out.println("ChatUser: init.");
        }

/* Get needed attributes from the html page. */


/*        if (getParameter("width") != null) {
            width = Integer.parseInt(getParameter("width"));
        } else {
            width = 250;
        }

        if (getParameter("height") != null) {
            height = Integer.parseInt(getParameter("height"));
        } else {
            height = 250;
        }

        if (getParameter("server") != null) {
            hostname = getParameter("server");
        }

        if (getParameter("port") != null) {
            hostport = Integer.parseInt(getParameter("port"));
        }

        if (getParameter("type") != null) {
            sessionType = getParameter("type");
        }*/

        lbl = new Font("Helvetica", Font.BOLD, 14);
        g   = new GridBagLayout();
        c   = new GridBagConstraints();

	c.fill      = GridBagConstraints.NONE;
	c.weightx   = 1.0;
	c.gridwidth = GridBagConstraints.REMAINDER;
 
//	f.setLayout(g);
 setLayout(g);
	p = new Panel();
	g.setConstraints(p, c);
//	f.add(p);

add(p);
	p.add(setNameButton = new Button("Set Name"));
	p.add(nameField     = new TextField(20)).setFont(lbl);
	p.add(signOffButton = new Button("SignOff"));
	signOffButton.disable();
 
	p = new Panel();
	g.setConstraints(p, c);
//	f.add(p);
add(p);
	p.add(new Label("Messages: "));
	p.add(messageArea = new TextArea(6, 30));
 
	p = new Panel();
	g.setConstraints(p, c);
	//f.add(p);
add(p);
	p.add(sayButton = new Button("Say"));
	sayButton.disable();
        setNameButton.disable();
	p.add(typeField = new TextField(20));
      //  f.resize(width, height);
resize(width, height);
        
System.out.println("getting flag");        
 

             
    }
	
public void enable_but(){
	System.out.println("ButtonEnabled");
	 setNameButton.enable();  
}

    private boolean
    isConnected() {
        if (ChatUser_Debug) {
            System.out.println("ChatUser: isConnected: " + connected);
        }

        return(connected);
    }


    private boolean
    connect() {
	if (ChatUser_Debug) {
            System.out.println("ChatUser: connect.");
        }

	if (name == null) {
	    throw new Error("need a non-null name to connect");
	}  

	try {
	    String sessionName = "ChatSession";

/* Create a chat client. */

            System.out.println("Creating a ChatMember...");
	    client = new ChatClient(name);

/* Resolve the chat session. */

	    try {
                String url = "coll://" + hostname + ":" + hostport +
			     "/" + sessionType + "/Session/" + sessionName;

		session = SessionFactory.createSession(url);

/*  Join the session and a named channel and set the channels data consumer. */
System.out.println("1");
		session.join(client);
System.out.println("1");
		channel = Channel.join(session, "ChatChannel", client);
		chatConsumer = new ChatConsumer(client.getName(), messageArea);
		channel.setConsumer(client, chatConsumer);

	        repaint();
            } catch (Exception e) {
                System.out.print("Caught exception in ");
		System.out.println("ChatUser.connect: " + e);
		if (ChatUser_Debug) {
		    e.printStackTrace();
		}
		return(false);
            }
        } catch (Throwable th) {
            System.err.println("ChatUser: connect caught: " + th);
            if (ChatUser_Debug) {
		th.printStackTrace();
            }
	    throw new Error("SetClient.start failed : " + th);
        }
	return(true);
    }

public void showNames(String[] names){
	cf=new ClientFrame(names);
	cf.start();
}

/*  Convert the users message to bytes and send it over the channel. */

    private void
    writeLine(String message) {
        if (ChatUser_Debug) {
            System.out.println("ChatUser: writeLine: " + message);
        }

	if (isConnected()) {
            try {
		data = new Data(message);
		data.setPriority(Channel.HIGH_PRIORITY);
                channel.sendToAll(client, data);
            } catch (Exception e) {
                System.out.print("Caught exception in ");
                System.out.println("ChatUser.writeLine(): " + e);
                if (ChatUser_Debug) {
		    e.printStackTrace();
		}
            }
	}
    }


    private void
    disconnect() {
        try {
            if (ChatUser_Debug) {
                System.out.println("ChatUser: disconnect.");
            }
/* Leave the channel and leave the session. */

            channel.leave(client);
            session.leave(client);
        } catch (Exception e) {
            System.err.println("Caught exception while trying to " +
			       "disconnect from chat server: " + e);
            if (ChatUser_Debug) {
		e.printStackTrace();
	    }
        }
    }


    public void
    start() {
        if (ChatUser_Debug) {
            System.out.println("ChatUser: start.");
        }
 System.out.println("ChatUser: start.");
       if (running == null) {
            running = new Thread(this);
running.setDaemon(true);
running.setPriority(Thread.MAX_PRIORITY);
            running.start();
System.out.println("Running");
        }


    }


    public void
    stop() {
        if (ChatUser_Debug) {
            System.out.println("ChatUser: stop.");
        }
 System.out.println("ChatUser: stop.");
       if (running != null) {
            running.stop();
            running = null;
        }
    }    


    public void
    run() {
        if (ChatUser_Debug) {
            System.out.println("ChatUser: run.");
        }
 System.out.println("ChatUser: run.");

    }


    public void
    destroy() {
        if (ChatUser_Debug) {
            System.out.println("ChatUser: destroy.");
        }
       running = null;

       disconnect();
	dispose();
//cf.destroy();
    }


/*public boolean handleEvent(Event event){
	System.out.println("Event occured");
return true;
}*/
    public boolean action(Event event, Object obj) {
System.out.println("entering action");
        if (ChatUser_Debug) {
            System.out.println("ChatUser: action.");
        }
System.out.println("entering action");
	if ("SignOff".equals(obj)) {
	    sayButton.disable();
	    signOffButton.disable();
	    setNameButton.disable();
	    disconnect();
	    return(true);
	} else if ("Say".equals(obj)) {

// Say the message field info to all the players

	    if (session == null) {
		return(true);
	    } 
	    try {
		writeLine(typeField.getText());
	    } catch (Exception e) {
		System.err.println("Caught exception while invoking Say: " + e);
                if (ChatUser_Debug) {
		    e.printStackTrace();
		}
	    } 
	    return(true);
	} else if ("Set Name".equals(obj)) {

/* Set the name */

	    name = nameField.getText();
System.out.println("Name ="+ name);
	    if (name == null || name == "")  {
		nameField.setText("Need to give a name before \"Set Name\"");
		return(true);
	    } else {
		connected = connect();
		nameField.setEditable(false);
		setNameButton.disable();
		signOffButton.enable();
		sayButton.enable();
	    }
	    return(true);
	} 
        return(false);
    }
}






