
/*
 * %W% %E%
 *
 * Copyright (c) 1993-1997 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You shall
 * not disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */

package webflow.modules.demo.collab;

import webflow.modules.demo.image.*;
import SharedData.*;
import java.awt.*;
import java.applet.Applet;
import java.awt.image.*;

/**
 * This is just a simple server/client based proof-of-concept
 * implementation to make sure that the Shared Data classes have
 * all the required API in them.
 *
 * It's based on the chat demonstration which is part of the
 * west-coast rmi distribution.
 *
 * @version     0.92 24 February 1997
 * @author      Rich Burridge
 */

class
ImageToolConsumer implements ChannelConsumer, ImageToolDebugFlags {

    /** The name of this channel consumer. */
    protected String name;

    /** The location to write all messages received. */
    int[] pixels;
    Image img;
    MediaTracker tracker= new MediaTracker(null);
    ImageToolUser ImageTool;
    public
    ImageToolConsumer(String name, Image img, ImageToolUser ImageTool) {
        if (ImageToolConsumer_Debug) {
            System.out.println("ImageToolConsumer: constructor.");
        }

        this.name = name;
        this.img = img;
        this.ImageTool= ImageTool;
    }
 
 
    public synchronized void
    dataReceived(Data data) {
        String  message;
        int     position   = 0;
	int     priority   = data.getPriority();
	String  senderName = data.getSenderName();
        Channel channel    = data.getChannel();
        byte[]  theData    = data.getData();

        if (ImageToolConsumer_Debug) {
            System.out.println("ImageToolConsumer: dataReceived " +
                               " Priority "    + priority +
                               " Channel "     + channel +
                               " Sender name " + senderName +
                               " Data "        + theData);
        }

         
/* Construct message and output it to the end of the message area. */
         message =  new String(theData, 0);

         ImageTool.redraw(message);
      }         
}
