
/*
 * @(#)ImageToolUser.java	1.1 97/02/27
 *
 * Copyright (c) 1993-1997 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You shall
 * not disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */

package webflow.modules.demo.collab;

import webflow.modules.demo.image.*;

import SharedData.*;
import java.awt.*;
import java.applet.Applet;
import java.awt.image.*;
import java.util.*;
import gjt.filter.*;
import java.io.*;
import java.net.*;
import java.applet.*;

/**
 * This is just a simple server/client based proof-of-concept
 * implementation to make sure that the Shared Data classes have
 * all the required API in them.
 *
 * It's based on the chat demonstration which is part of the
 * west-coast rmi distribution.
 *
 * @version     0.92 27 February 1997
 * @author      Rich Burridge
 */

public class
ImageToolUser  extends Frame implements ImageToolDebugFlags, Runnable {
    Button    setNameButton;
    Button    sayButton;
    Button    signOffButton;
    TextField nameField;
    TextField typeField;
    TextArea  messageArea;
    ClientFrame cf;
Panel panel;
    /** The name of this Client. */
    protected String name;

    /** The ImageTool session that this client application will join. */
    private Session session;

    /** The client that will be joining the session and channel. */
    private ImageToolClient client;

    /** The channel that this client application will use to send data. */
    private Channel channel;

    private Channel channel2;
 
    /** The consumer of all data sent over the channel. */
    private ImageToolConsumer ImageToolConsumer;

    private ImageToolConsumer2 ImageToolConsumer2;

    /** The data that will be sent over the channel. */
    private Data data;

    /** Indicates if the client is successfully connected to the server. */
    boolean connected = false;
    /**Indicates whether the client has sent has sent confirmation or no*/
    int  bool=0;

    static boolean superuser= false;

/* Default setup, will mostly be overriden by attributes. */

    int     width       = 450;
    int     height      = 450;
    String  hostname    = "stard";
    int     hostport    = 4461;
    String  sessionType = "socket";
    public DataSocketImg si;
    private Thread running = null;

    public byte[] buf;
    public Image img;
    public int imgw,imgh;
    MediaTracker tracker = new MediaTracker(this);
    String fname,urlstr;
    public int[] pixel;
    Button[] bt = new Button[16];
    public ImageCanvas viewer;
    public boolean disconnected = true;
    ImgApp app1;

     String hostName;
    int portNum;
    
        public ImageToolUser(String host,int port,ImgApp app){
                si=new DataSocketImg(host,port,this);
                app1=app;
       }

    public synchronized void
    init() {
        Panel p;
        Font               lbl;
        GridBagLayout      g;
        GridBagConstraints c;

        if (ImageToolUser_Debug) {
            System.out.println("ImageToolUser: init.");
        }

/* Get needed attributes from the html page. */

/*        if (getParameter("width") != null) {
            width = Integer.parseInt(getParameter("width"));
        } else {
            width = 250;
        }

        if (getParameter("height") != null) {
            height = Integer.parseInt(getParameter("height"));
        } else {
            height = 250;
        }

        if (getParameter("server") != null) {
            hostname = getParameter("server");
        }

        if (getParameter("port") != null) {
            hostport = Integer.parseInt(getParameter("port"));
        }

        if (getParameter("type") != null) {
            sessionType = getParameter("type");
        }*/
panel=new Panel();
        lbl = new Font("Helvetica", Font.BOLD, 14);
        g   = new GridBagLayout();
        c   = new GridBagConstraints();

	c.fill      = GridBagConstraints.NONE;
	c.weightx   = 1.0;
	c.gridwidth = GridBagConstraints.REMAINDER;
 resize(width,height);
add(panel);

        fname= "doc/images/frog.gif";
        System.out.println("got frog.gif");
        urlstr= "http://www.cat.syr.edu/~shrideep";    
        System.out.println("Codebase for Img " + fname);
        getImg(fname);
        iToPixels(img);     

        Panel editingPanel= new Panel();
        editingPanel.setLayout(new BorderLayout());
        viewer = new ImageCanvas(img);
        viewer.setBackground(Color.white);
        panel.add(viewer);      
        
        Panel editControls = new Panel();
        editControls.setLayout(new BorderLayout());

        Panel editControls1 = new Panel();
        Panel editControls2 = new Panel();
        Panel editControls3 = new Panel();

        editControls1.setLayout(new FlowLayout());
        editControls1.add(bt[0] = new Button("graying"));
        editControls1.add(bt[1] = new Button("negative"));
        //editControls1.add(bt[2] = new Button("bleach"));
        editControls1.add(bt[2] = new Button("flip"));

        editControls2.setLayout(new FlowLayout());
        //editControls2.add(bt[3] = new Button("wave"));
        //editControls2.add(bt[4] = new Button("eDetect"));
        //editControls2.add(bt[5] = new Button("emboss"));
        //editControls2.add(bt[67] = new Button("flop"));

        editControls3.setLayout(new FlowLayout());
        editControls3.add(bt[3] = new Button("sharpen"));
        //editControls3.add(bt[4] = new Button("smaller"));
        editControls3.add(bt[4] = new Button("smooth"));
        editControls3.add(bt[5] = new Button("blur"));

       
        for (int i=0;i<6;i++)
           bt[i].disable();
         editControls.add("North",editControls1);
        editControls.add("Center",editControls2);
        editControls.add("South",editControls3);
       
        Panel ImageToolPanel = new Panel();
	ImageToolPanel.setLayout(g);
 
	p = new Panel();
	g.setConstraints(p, c);
        editingPanel.add("Center", viewer);
	p.add(setNameButton = new Button("Collaborate"));
	p.add(nameField     = new TextField(15)).setFont(lbl);
p.setBackground(Color.black);
        p.setForeground(Color.white);        
 editingPanel.add("South", p);

	p = new Panel();
	g.setConstraints(p, c);
	ImageToolPanel.add(p);
	p.add(messageArea = new TextArea(5, 25));
    setNameButton.disable();
        Panel p1 = new Panel();
        p1.setLayout(g);
        g.setConstraints(p1, c);
        p1.add(sayButton = new Button("Say"));
        sayButton.disable();
        p1.add(typeField = new TextField(30));
 //       p1.add(signOffButton = new Button("SignOff"));
  //      signOffButton.disable();
        setLayout(new BorderLayout());
        panel.add("North", editingPanel);
        panel.add("East",editControls);
        panel.add("West",ImageToolPanel);
        panel.add("South",p1);
        panel.resize(width, height);
        show();
    }

    public void update(Graphics g) { paint(g); } 
    
    public void paint(Graphics g) {
      g.drawImage(img,30,30,imgw,imgh,this);
    }
    
    public Image pixelsToI(int[] pix,int iw, int ih) {
      return createImage(new MemoryImageSource(iw,ih,pix,0,iw));
    }
    
    public void redraw(String bname) {
      if ("graying".equals(bname)) {   
	int r, g, b, p;
	Color col;
	for (int i=0; i<pixel.length; i++) {
	  col = toRGB(pixel[i]);
	  r  = (int)col.getRed();
	  g  = (int)col.getGreen();
	  b  = (int)col.getBlue();
	  r  = (int)(0.3*r + 0.6*g +0.1*b);
	  pixel[i] = toPixel(r,r,r);
	}
	System.out.println("Filter done..." + pixel.length+" length");             
	viewer.image=pixelsToI(pixel,imgw,imgh);
	viewer.repaint();
      }

      if ("wojtek".equals(bname)) {
          superuser= false;
          System.out.println("SuperUser is out ...."); 
      }

      if ("Wojtek".equals(bname)) {
          superuser= true;
          System.out.println("SuperUser is IN!!!!! ...."); 
      }


      if ("flip".equals(bname)) { 
	if ((superuser == true) &&
             (("tom").equals(name) ) ||("wojtek").equals(name) ) {
	      flipFilter flip;
	      flip = new flipFilter();
	      pixel= flip.filter(pixel, imgw,imgh);
              viewer.image=pixelsToI(pixel,imgw,imgh);
	      viewer.repaint();}
        else if (superuser==false) {
              flipFilter flip;
	      flip = new flipFilter();
	      pixel= flip.filter(pixel, imgw,imgh);
              viewer.image=pixelsToI(pixel,imgw,imgh);
	      viewer.repaint();}
      }
    
      if ("flop".equals(bname)) { 
    System.out.println("You clicked to flop the image..");
	flopFilter flop;
	flop = new flopFilter();
    System.out.println("After flopFilter object instantiation");
	pixel= flop.filter(pixel, imgw,imgh);
	viewer.image= pixelsToI(pixel,imgw,imgh);
    System.out.println("After pixelstoI method...");
	viewer.repaint();
    System.out.println("After repainting of viewer...");
   }
      
      if ("wave".equals(bname)) {
	fwaveimage wavetext;
	wavetext = new fwaveimage();
	wavetext.setBackground(Color.white);
	wavetext.setparameter("10", 0);
	wavetext.setparameter("10", 1);
	wavetext.setparameter("0", 2);
	wavetext.setparameter("0", 3);
	wavetext.setparameter("0", 4);
	wavetext.setparameter("-1", 5);
	pixel = wavetext.filter(pixel, imgw, imgh);
	viewer.image= pixelsToI(pixel,imgw,imgh);
	viewer.repaint();
      }
      
      
      if ("negative".equals(bname)) { 
	
	negFilter neg;
	neg = new negFilter();
	pixel= neg.filter(pixel, imgw,imgh);
	
	viewer.image= pixelsToI(pixel,imgw,imgh);
	viewer.repaint();}
      
      if ("bleach".equals(bname)) { 
	
	bleachFilter bleach;
	bleach = new bleachFilter();
	pixel= bleach.filter(pixel, imgw,imgh);
	
	viewer.image= pixelsToI(pixel,imgw,imgh);
	viewer.repaint();}
      
      if ("eDetect".equals(bname)) { 
	fedgedetectimage e;
	e = new fedgedetectimage();
	e.setparameter("West", 0);
	pixel = e.filter(pixel, imgw, imgh);
	
	
	viewer.image= pixelsToI(pixel,imgw,imgh);
	viewer.repaint();}
      
      if ("emboss".equals(bname)) { 
	
	fembossimage e;
	e = new fembossimage();
	e.setparameter("West", 0);
	pixel = e.filter(pixel, imgw, imgh);
	
	viewer.image= pixelsToI(pixel,imgw,imgh);
	viewer.repaint();}
     if ("sharpen".equals(bname)) { 
        fsharpen e;
        e = new fsharpen();
        pixel = e.filter(pixel, imgw, imgh);
        viewer.image= pixelsToI(pixel,imgw,imgh);
	viewer.repaint();}

     if ("blur".equals(bname)) { 
        fblur blur;
        blur = new fblur();
        blur.setparameter("2",0);
        pixel = blur.filter(pixel, imgw, imgh);
        viewer.image= pixelsToI(pixel,imgw,imgh);
	viewer.repaint();}



  }

    public void getImg(String name) {
      img = app1.getImage(app1.getCodeBase(),name);
      tracker.addImage(img,0);
      try { tracker.waitForID(0);
	  } catch (InterruptedException e) {}
    }
    
    public void iToPixels(Image I) {
      imgw = I.getWidth(null); imgh = I.getHeight(null);
      pixel = new int[imgw*imgh]; 
      PixelGrabber pg = new PixelGrabber(img,0,0,imgw,imgh,pixel,0,imgw);
      try {
	pg.grabPixels();
      } catch (InterruptedException e) {};
    }
    
    public Color toRGB(int p) {
      int r = (p >> 16) & 0xff;
      int g = (p >>  8) & 0xff;
      int b = (p >>  0) & 0xff;
      return new Color(r,g,b);
    }
    
    public int toPixel(int r, int g, int b) {
      return (255 << 24) | (r << 16) | (g << 8) | (b << 0); }
    
    private boolean
      isConnected() {
        if (ImageToolUser_Debug) {
	  System.out.println("ImageToolUser: isConnected: " + connected);
        }
	
        return(connected);
      }
    
    public void enable_but()
    {
      for (int i=0;i<6;i++)
          bt[i].enable();
setNameButton.enable();

    }        
     private boolean
      connect() {
	if (ImageToolUser_Debug) {
	  System.out.println("ImageToolUser: connect.");
        }
	
	try {
	  String sessionName = "ImageToolSession";
	  
	  /* Create a ImageTool client. */
	  
	  System.out.println("Creating a ImageToolMember...");
	  client = new ImageToolClient(name +
	       (rrange(0, 1000) * rrange(0, 1000)));
	  
	  
	  /* Resolve the ImageTool session. */
	  
	  try {
	    String url = "coll://" + hostname + ":" + hostport +
	      "/" + sessionType + "/Session/" + sessionName;

            session = null;	    
	    session = SessionFactory.createSession(url);
	    System.out.println("process in full swing...");
	    /*  Join the session and a named channel and set the channels data consumer. */
	    
	    session.join(client);
            System.out.println( name + " joined to session...");

            
	    channel = Channel.join(session, "ImageToolChannel", client);
	    
	    System.out.println(name + " joined to Channel ...");
	    ImageToolConsumer = new ImageToolConsumer(client.getName(), img,this);
	    
	    channel.setConsumer(client, ImageToolConsumer);
	    System.out.println("Image Channel fine ..: ");
	    
	    channel2 = Channel.join(session, "ChChannel", client);
	    ImageToolConsumer2 = new ImageToolConsumer2(client.getName(), messageArea);
	    channel2.setConsumer(client, ImageToolConsumer2);
	    System.out.println("ImageTool channel is also fine ...");
	    disconnected= false;
	    repaint();
	    
	  } catch (SharedDataException e) {
	    System.out.print("Caught exception in ");
	    System.out.println("ImageToolUser.connect: " + e.typeToString(e.getType()));
	    if (ImageToolUser_Debug) {
	      e.printStackTrace();
	    }
	    return(false);
	  }
        } catch (Throwable th) {
	  System.err.println("ImageToolUser: connect caught: " + th);
	  if (ImageToolUser_Debug) {
	    th.printStackTrace();
	  }
	  throw new Error("SetClient.start failed : " + th);
        }
        System.out.println("ImageTool Session Resolved...");
	return(true);
      }
    
    
    /*  Convert the users message to bytes and send it over the channel. */
    
    private void
      writeLine(String message) {
        if (ImageToolUser_Debug) {
          //  System.out.println("ImageToolUser: writeLine: " + message);
        }
	
	if (isConnected()) {
	  try {
	    data = new Data(message);
	    data.setPriority(Channel.HIGH_PRIORITY);
	    channel.sendToAll(client, data);
	  } catch (Exception e) {
	    System.out.print("Caught exception in ");
	    System.out.println("ImageToolUser.writeLine(): " + e);
	    if (ImageToolUser_Debug) {
	      e.printStackTrace();
	    }
	  }
	}
      }
    
    
    private void
      writeLine2(String message) {
        if (ImageToolUser_Debug) {
	  System.out.println("ImageToolUser: writeLine: " + message);
        }
	
	if (isConnected()) {
	  try {
	    data = new Data(message);
	    data.setPriority(Channel.HIGH_PRIORITY);
	    channel2.sendToAll(client, data);
	  } catch (Exception e) {
	    System.out.print("Caught exception in ");
	    System.out.println("ImageToolUser.writeLine(): " + e);
	    if (ImageToolUser_Debug) {
	      e.printStackTrace();
	    }
	  }
	}
      }
    
    private void
       disconnect() {
        try {
	  if (ImageToolUser_Debug) {
	    System.out.println("ImageToolUser: disconnect.");
	  }
	  /* Leave the channel and leave the session. */
	  
	  
	  // channel.leave(client);
          channel.setConsumer(client, null);
           System.out.println("channel's consumer nullified...");
         // channel.leave(client);
          System.out.println("client left channel...");
          //displayListOfChannelClients();
          channel2.setConsumer(client, null);
          System.out.println("channel2's consumer nullified...");
	  //channel2.leave(client);
      System.out.println("client left channel2..");
	  session.leave(client);
      System.out.println("client left session...");
      //  displayListOfConnectedClients();
	  System.out.println("Imaging Tool User disconnected...");   
	  disconnected= true;
        } catch (Exception e) {
	  System.err.println("Caught exception while trying to " +
			     "disconnect from ImageTool server: " + e);
	  if (ImageToolUser_Debug) {

	    e.printStackTrace();
	  }
        }
      }

    public void displayListOfChannelClients() {
      try {
         String clientNames[] = channel.listClientNames();
         System.out.println("Number of Channel clients = " + clientNames.length );
 
         for (int i=0 ; i< clientNames.length ; i++) {
            System.out.println("Channel Client "+i + "is " + clientNames[i]);
         }
      }
      catch (Exception e) { System.out.println("Screwed up !!!!!!"); }
      

    }

    
    public void displayListOfConnectedClients() {
      try {
         String clientNames[] = session.listClientNames();
         System.out.println("Number of Session clients = " + clientNames.length );
 
         for (int i=0 ; i< clientNames.length ; i++) {
            System.out.println("Session Client "+i + "is " + clientNames[i]);
         }
      }
      catch (Exception e) { System.out.println("Screwed up !!!!!!"); }
      

    }
    public void checkSuperUser() {
      superuser = true;
      
    }

    public void exitChannels() {
      try { //channel.leave(client); 
              channel.setConsumer(client, null);
      //      channel2.leave(client);
      System.out.println("Channels no longer listened to!!!.");
      } catch (Exception e) {
	  System.err.println("Caught exception while trying to " +
			     "disconnect from ImageTool server: " + e);
	  if (ImageToolUser_Debug) {
	    e.printStackTrace();
	  }
        }
    }

    public void enterChannels() {
      try {
       System.out.println("Preperations to return in full swing ");
       //       channel = Channel.join(session, "ImageToolChannel", client);
       System.out.println("Image Channel fine ..: ");
       channel.setConsumer(client, ImageToolConsumer);
       System.out.println("Image Channel fine ..: ");
      }  catch (Exception e) {
	    System.out.print("Caught exception in ");
	    System.out.println("ImageToolUser.connect: " + e);
	    if (ImageToolUser_Debug) {
	      e.printStackTrace();
	    }
         } 
    }
    
    public void
      start() {
        if (ImageToolUser_Debug) {
	  System.out.println("ImageToolUser: start.");
        }
	
        if (running == null) {
	  running = new Thread(this);
	  running.start();
        }
      }
    
    
    public void
      stop() {
        if (ImageToolUser_Debug) {
	  System.out.println("ImageToolUser: stop.");
        }
	
        if (running != null) {
	  running.stop();
	  running = null;
        }
      }    
    
    
    public void
      run() {
        if (ImageToolUser_Debug) {
	  System.out.println("ImageToolUser: run.");
        }
      }
    
    
    public void
      destroy() {
        if (ImageToolUser_Debug) {
	  System.out.println("ImageToolUser: destroy.");
        }
        if(running !=null)
         {
        running = null;
       System.out.println("running thread nullified...");
         }
        if(disconnected == false)
         {
        disconnect();
        System.out.println("After disconnect..");
          }
        dispose();
        System.out.println("After dispose...");
      }
    
    private int
      rrange(int low, int high) {
        return((int)(Math.random() * (high - low + 1) + low));
      }
    
    public boolean
      action(Event event, Object obj) {
        if (ImageToolUser_Debug) {
	  System.out.println("ImageToolUser: action.");
        }
      /*  if ("SignOff".equals(obj)) {
	  disconnect();
         System.out.println("Client is signing off from the session...");
	  return(true);
	} */
        
	
	if ("Collaborate".equals(obj)) {
	  //           name = System.getProperty("user.name") + ":" +
	  // 	       (rrange(0, 1000) * rrange(0, 1000));
	  name = nameField.getText();
	  if (name == null || name =="") {
	    nameField.setText("Need to give a name before \"Set Name\"");
	    return(true);
	  }
	  else {  connected= connect();
		  nameField.setEditable(false);
//signOffButton.enable(); 
                sayButton.enable();

		  if ("wojtek".equals(name) ) {
		    superuser = true;
		    System.out.println("Super User is IN!!!!!");
                    try {  writeLine("Wojtek");
         	    }  catch (Exception e) {
	           System.err.println("Caught exception while invoking fil"+ e);
	              if (ImageToolUser_Debug) {
            	       e.printStackTrace();
	            }
	               }
		  }
		  
		}
	  return true;
        }
	
	if(("flop").equals(obj)) {
	    if (disconnected) {
	      redraw("flop");
	      return true;
	    }
	  if ((("tom").equals(name) && superuser == false) ||("wojtek").equals(name) ) {
	    try {
	      writeLine("flop");
	    }  catch (Exception e) {
	      System.err.println("Caught exception while invoking fil"+ e);
	      if (ImageToolUser_Debug) {
		e.printStackTrace();
         System.out.println("Problem in flopping the image...");
	      }
 	    } 
            System.out.println("Bytes dumped");  
	    
	  }
	  return(true);
	}
	
        if(("wave").equals(obj)) {
            if (disconnected) {
	      redraw("wave");
	      return true;
	  }

	  if ((("tom").equals(name) && superuser == false) ||("wojtek").equals(name) ) {
	    try {
	      writeLine("wave");
	    }  catch (Exception e) {
	      System.err.println("Caught exception while invoking fil"+ e);
	      if (ImageToolUser_Debug) {
		e.printStackTrace();
	      }
 	    } 
            System.out.println("Bytes dumped");  
	  }
	  return(true);
	}
	
        if(("eDetect").equals(obj)) {
      
	  if (disconnected) {
	    redraw("eDetect");
	    return true;
	  }
	  if ((("tom").equals(name) && superuser == false) ||("wojtek").equals(name) ) {     
	    try {
	      writeLine("eDetect");
	    }  catch (Exception e) {
	      System.err.println("Caught exception while invoking fil"+ e);
	      if (ImageToolUser_Debug) {
		e.printStackTrace();
	      }
	    } 
	    System.out.println("Bytes dumped");  
	  }
	  return(true);
	}
	
        if(("emboss").equals(obj)) {
	   if (disconnected) {
	      redraw("emboss");
	      return true;
	   }
	  if ((("tom").equals(name) && superuser == false) ||("wojtek").equals(name) ) {         
	    try {
	      writeLine("emboss");
	    }  catch (Exception e) {
	      System.err.println("Caught exception while invoking fil"+ e);
	      if (ImageToolUser_Debug) {
		e.printStackTrace();
	      }
 	    } 
            System.out.println("Bytes dumped");  
	  }
	  return(true);
	}
	
        if(("bleach").equals(obj)) {
	  if (disconnected) {
	    redraw("bleach");
	    return true;
	  }

          if ((("tom").equals(name) ) ||("wojtek").equals(name) ) {
	  try {
	    writeLine("bleach");
	  }  catch (Exception e) {
	    System.err.println("Caught exception while invoking fil"+ e);
	    if (ImageToolUser_Debug) {
	      e.printStackTrace();
	    }
	  } 
	  System.out.println("Bytes dumped");  
	  return(true);
	}
        }
	
        if(("negative").equals(obj)) {
	  if (disconnected) {
	    redraw("negative");
	    return true;
	  }
	  try {
	    writeLine("negative");
	  }  catch (Exception e) {
	    System.err.println("Caught exception while invoking fil"+ e);
	    if (ImageToolUser_Debug) {
	      e.printStackTrace();
	    }
	  } 
	  System.out.println("Bytes dumped");  
	  return(true);
	}

		
        if(("flip").equals(obj)) {
	  if (disconnected) {
	    redraw("flip");
	    return true;
	  }

          if (superuser== false) {
            try {
	     writeLine("flip");
	      }  catch (Exception e) {
	      System.err.println("Caught exception while invoking fil"+ e);
	       if (ImageToolUser_Debug) {
	       e.printStackTrace();
	     }
	   } 
	  System.out.println("Bytes dumped");  
	  return(true);
     
          }

          if ((("tom").equals(name) ) ||("wojtek").equals(name) ) {
	  try {
	    writeLine("flip");
	  }  catch (Exception e) {
	    System.err.println("Caught exception while invoking fil"+ e);
	    if (ImageToolUser_Debug) {
	      e.printStackTrace();
	    }
	  } 
	  System.out.println("Bytes dumped");  
	  return(true);
	  
          }
	} 
	
	if ("graying".equals(obj)) {
            if (disconnected) {
	        redraw("graying");
	        return true;
	    }	  
	  // Say the message field info to all the players
          if (superuser== true ) {
	    redraw("graying");
	    return true;
	  }
	  
	  try {
	    writeLine("graying");
	  }  catch (Exception e) {
	    System.err.println("Caught exception while invoking fil"+ e);
	    if (ImageToolUser_Debug) {
	      e.printStackTrace();
	    }
	  } 
	  System.out.println("Bytes dumped");  
	  return(true);
	} 
	
       if(("blur").equals(obj)) {
	  if (disconnected) {
	    redraw("blur");
	    return true;
	  }
	  try {
	    writeLine("blur");
	  }  catch (Exception e) {
	    System.err.println("Caught exception while invoking fil"+ e);
	    if (ImageToolUser_Debug) {
	      e.printStackTrace();
	    }
	  } 
	  System.out.println("Bytes dumped");  
	  return(true);
	}

        if(("sharpen").equals(obj)) {
	  if (disconnected) {
	    redraw("sharpen");
	    return true;
	  }
	  try {
	    writeLine("sharpen");
	  }  catch (Exception e) {
	    System.err.println("Caught exception while invoking fil"+ e);
	    if (ImageToolUser_Debug) {
	      e.printStackTrace();
	    }
	  } 
	  System.out.println("Bytes dumped");  
	  return(true);
	}

        if ("Say".equals(obj)) {
	  
	  // Say the message field info to all the players
	  
	  if (session == null) {
	    return(true);
	  } 
	  try {
	    writeLine2(typeField.getText());
	  } catch (Exception e) {
	    System.err.println("Caught exception while invoking Say: " + e);
	    if (ImageToolUser_Debug) {
	      e.printStackTrace();
	    }
	  } 
	  return(true);
	}
	
	if ("smaller".equals(obj)) {
           exitChannels();
           try {
	    writeLine(name);
	    }  catch (Exception e) {
	     System.err.println("Caught exception while invoking fil"+ e);
	     if (ImageToolUser_Debug) {
	       e.printStackTrace();
	     }
	   }
           return(true);

        }

        if ("smooth".equals(obj)) {
           enterChannels();
           if("wojtek".equals(name)) { 
           try {
	    writeLine("Wojtek");
	    }  catch (Exception e) {
	     System.err.println("Caught exception while invoking fil"+ e);
	     if (ImageToolUser_Debug) {
	       e.printStackTrace();
	     }
	   }
           return(true);

	   } 

	}
        return(false);
      }
    
}


